C      PROGRAM MAIN(EINFO  ,LPFOU ,TAPE5=EINFO  ,TAPE6=LPFOU ,TAPE2,
C     &TAPE10,TAPE11,TAPE12,TAPE13,ZZZG67,TAPE67=ZZZG67)
C                            MAINPROGRAM
C
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C +                                                                    +
C + THE MAINPROGRAM  READS THE SELECTION CARDS (SPSCAN,TDSCOR,ABSORB,  +
C + SPHERE,AVERAG,REFINE,FOURIE,ERRMAP,PDFMAP,POTCAL,ARBSEC,PLOTTE,    +
C + BONVIB,LISTFC,MULPD,FINISH,NTITEL,INFO## AND CALLS THE             +
C + CORRESPONDING OVERLAYS.                                             +
C + WRITTEN BY E. PERENTHALER AND U. ZUCKER MPI-FKF (1979)             +
C +                                                                    +
C + (LAST UPDATE FEBRUARY 1982)                                        +
C +                                                                    +
C + IN ADDITION THE FOLLOWING SUBROUTINES ARE CALLED                   +
C + TITEL, TIME, ANFANG (ENTRY 'ENDE')                                 +
C +                                                                    +
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C
C---- DIMENSION DECLARATION FOR PROGRAMS   OF THE NEW GENERATION
C
C   - IN THE ARRAY  LINE  ONE MAY WRITE THE NAME OF THAT PERSON,
C     WHO IS RESPONSIBLE FOR CORRECT RUNNING OF PROMETHEUS
C   - MAXLIN  IS THE NUMBER OF LINES PER PAGE FOR THE PRINTER USED.
C   - IN  IS LOGICAL NUMBER OF STANDARD INPUT UNIT
C   - SAME FOR OUTPUT-UNIT
C   - NUMBER  IS THE DIMENSION OF FIELDS IN COMMON/OVNAM/
C
      DIMENSION LINE(11)
C
      CHARACTER ISTAR1*4,ISTAR2*2,IAY(21)*2
      CHARACTER*4 IOVERL(21)
      COMMON /ALL/IN,IOUT,LINE,MAXLIN,ISTAR3,IREW19
C
C---- DATA STATEMENTS
C
C---- DIMENSION OF FIELDS IN COMMON /OVNAM/
C
      DATA NUMBER/21/
C
C---- NAME OF RESPONSIBLE MAN
C
      DATA LINE/4HSTEU,4HRER ,4H    ,4H    ,4H    ,4H    ,
     &          4HZIMM,4HER 2,4H42  ,4H    ,4H    /
C
C---- LOGICAL UNITS FOR INPUT (IN) AND OUTPUT (IOUT)
C
      DATA IN,IOUT/05,06/
C
C---- TABLE OF LEGAL OVERLAY NAMES
C
      DATA IOVERL/'SPSC','TDSC','ABSO','SPHE','AVER','REFI','FOUR',
     &'ERRM','PDFM','POTC','ARBS','PLOT','BONV','LIST','PRED','FINI',
     &'NTIT','INFO','OPTI','    ','MULP'/
      DATA IAY/'AN','OR','RB','RE','AG','NE','IE','AP','AP','AL','EC',
     &'TE','IB','FC','ES','SH','LE','  ','ON','  ','DF'/
C
C---- INITIALIZE
C
C
      OPEN(5,FILE="einfo")
      OPEN(6,FILE="lpfou")
      OPEN(67,FILE="ZZZG67")
      OPEN(02,FILE="ftn02",FORM="UNFORMATTED")
      OPEN(10,FILE="ftn10",FORM="UNFORMATTED")
      OPEN(11,FILE="ftn11",FORM="UNFORMATTED")
      OPEN(12,FILE="ftn12",FORM="UNFORMATTED")
      OPEN(13,FILE="ftn13",FORM="UNFORMATTED")
C---- LOGICAL UNIT OF THAT FILE ON WHICH PLOTTING ORDERS TO BE
C     WRITTEN.
C
      IPLOT=19
C
C---- MAXIMUM LINES PER PAGE OF PRINTER USED.
C
      MAXLIN = 63
C
C---- OTHERS
C
      IREW19=0
      IZAEHL=0
      ILAB = 0
      IERR = 0
      M    = 0
      ITITEL = 0
      ISHORT = 0
C
C---- THE VARIABLE ITOP IS SET TO 1, IF COVER IS PRINTED. OTHERWISE
C     IT COULD HAPPEN THAT ERRORMESSAGES WILL BE PRINTED INSIDE COVER.
C
      ITOP = 0
C
C---- READ LABEL OF OVERLAY. COMPARE WITH TABLE OF LEGAL NAMES AND
C     SWITCH.
C
C---- SET CLOCK TO START
C
   01 CONTINUE
      IF(ITITEL.EQ.1) ITOP = 1
C

   02 READ (IN,10,END=2050) ISTAR1,ISTAR2,ISTAR3
   10 FORMAT (A4,A2,I1)
C
      IF(ISTAR3.NE.1) ISTAR3=0
      IF(ISTAR1.EQ.IOVERL(19)) ISHORT=1
      IF(ISHORT.EQ.1) ISTAR3 = 1
      IOVERL (NUMBER) = ISTAR1
      DO 20 I = 1,NUMBER
      ILAB = I
   20 IF (ISTAR1 .EQ.IOVERL(I)) GO TO 30
C
C---- IF THIS IS THE FIRST REQUEST AND IS IT NOT EQUAL *NTITLE*
C     PRINT THE MAINCOVER
C
   30 IF(ITITEL.EQ.0 .AND. I.NE.17) CALL TITEL(IOUT)
C
      IF(I.NE.17)M=1
      ITITEL = 1
C
      GO TO (100,200,300,400,500,600,700,800,900,1000,1100,1200,1300,
     &1400,1500,3000,02,02,02,2000,1600),ILAB
  100 CONTINUE
      GO TO 01
  200 CONTINUE
      GO TO 01
  300 CONTINUE
      GO TO 01
  400 CONTINUE
      GO TO 01
  500 CONTINUE
      GO TO 01
  600 CONTINUE
C     CALL CALREF
      GO TO 01
  700 CONTINUE
      CALL FOURIE
      GOTO 01
  800 CONTINUE
      GOTO 01
  900 CONTINUE
C     CALL PDFMAPS
      GOTO 01
 1000 CONTINUE
      GO TO 01
 1100 CONTINUE
C     CALL ARBSEC
      GOTO 01
 1200 CONTINUE
      GOTO 01
 1300 CONTINUE
      GOTO 01
 1400 CONTINUE
      GOTO 01
 1500 CONTINUE
      GO TO 01
 1600 CONTINUE
C     CALL MULPDF
      GO TO 01
C
C---- ERROR MESSAGES
C
 2000 IF(ITOP.EQ.0) WRITE(IOUT,2010)
      ITOP = 1
      WRITE (IOUT,2020) ISTAR1,ISTAR2
 2010 FORMAT(1H1)
 2020 FORMAT(/1X,5(1H*),37HWARNING - INSTEAD OF A PROGRAM   NAME,
     & 2H ",A4,A2,40H" WAS READ.    THE CARD WILL BE IGNORED.)
C
      IZAEHL=IZAEHL+1
      IF(IZAEHL.GT. 3) GOTO 2030
      GO TO 02
 2030 WRITE(IOUT,2040)
 2040 FORMAT(//,1X,34HTHERE ARE TOO MANY ILLEGAL CARDS. /
     & 55H THE PROGRAM   SUPPOSE A FATAL ERROR - JOB TERMINATED. )
      IERR = 1
      GO TO 3000
C
 2050 WRITE(IOUT,2060)
 2060 FORMAT(5(/),1X,45H*END OF FILE* WAS READ ON STANDARD INPUT UNIT,
     & 17H. JOB TERMINATED.)
      IERR = 1
C
 3000 IF(IREW19.EQ.0)GOTO 3020
      WRITE(IOUT,3010) IPLOT
 3010 FORMAT(44H0*END OF FILE* WRITTEN TO THE PLOTTING FILE. ,
     & 14H (LOG.-NO. IS ,I4,1H) )
C
C---- THERE ARE TWO POSSIBILITIES OF GENERATING END OF FILE ON PLOTTER
C     FILE IPLOT. THE FIRST WAY IS BY CALLING OVERLAY PLOTT AGAIN  AND
C     AND DO IT THERE. (NOT POSSIBLE ON HONEYWELL BULL). THE SECOND IS
C     BY DOING IT HERE. ON SOME COMPUTERS LIKE UNIVAC 1110 ON EXEC  IT
C     IS NOT RECOMMENDABLE, BECAUSE OF  THE GREAT  CORE ALLOCATION  OF
C     THE PLOTTING SOFTWARE.
C
C     CALL LLINK("PLOTT")
C     CALL PLOTTE(IREW19,1)
C     CALL PLOT(0.,0.,999)
 3020 CONTINUE
C     CALL TIME (100,IOVERL,IAY,TTINI,TOVINI)
      IF(IERR.EQ.0) WRITE(IOUT,3030)
      IF(IERR.EQ.1) WRITE(IOUT,3040)
 3030 FORMAT(19H0NORMAL TERMINATION)
 3040 FORMAT(4(/),21H ABNORMAL TERMINATION)
C
C
      STOP
      END
                         SUBROUTINE TITEL(IOUT)
C
C       THIS ROUTINE GENERATES THE COVER OF THE SYSTEM PROMETHEUS
C
C             PROGRAMMERS   E. PERENTHALER AND U. ZUCKER
C
C                             NOVEMBER 1980
C
C----            IOUT IS LOGICAL NUMBER OF OUTPUT UNIT
C
C---- PRINT COVER. (THERE ARE MORE THAN ONE FORMAT STATEMENT, BECAUSE
C      OF A POSSIBLE MAXIMUM NUMBER OF CONTINUATION CARDS ALLOWED)
C
      WRITE(IOUT,1)
      WRITE(IOUT,2)
      WRITE(IOUT,3)
      WRITE(IOUT,4)
      WRITE(IOUT,5)
C
C---- WRITE COVER.   FIRST IN GREAT LETTERS    PROMETHEUS
C
C---- FIRST LINE
    1 FORMAT(1H1,4(/),10X,8(1HX),3X,8(1HX),5X,6(1HX),3X,3(1HX),4X,3(1HX
     & ),1X,10(1HX),1X,11(1HX),1X,3(1HX),4X,3(1HX),1X,10(1HX),1X,3(1HX
     & ),4X,3(1HX),3X,8(1HX)/
C---- SECOND LINE
     & 10X,9(1HX),2X,9(1HX),3X,8(1HX),2X,3(1HX),4X,3(1HX),1X,10(1HX),1
     & X,11(1HX),1X,3(1HX),4X,3(1HX),1X,10(1HX),1X,3(1HX),4X,3(1HX),1X
     & ,10(1HX)/
C---- THIRD LINE
     & 10X,3(1HX),4X,3(1HX),1X,3(1HX),4X,3(1HX),1X,3(1HX),4X,3(1HX),1X
     & ,3(1HX),4X,3(1HX),1X,3(1HX),12X,3(1HX),5X,3(1HX),4X,3(1HX),1X,3
     & (1HX),8X,3(1HX),4X,3(1HX),1X,3(1HX)/
C---- FOURTH LINE
     & 10X,3(1HX),4X,3(1HX),2(1X,3(1HX),4X,3(1HX)),1X,4(1HX),2X,4(1HX)
     & ,1X,3(1HX),12X,3(1HX),5X,3(1HX),4X,3(1HX),1X,3(1HX),8X,3(1HX),4
     & X,3(1HX),1X,3(1HX)/
C---- FIFTH LINE
     & 10X,9(1HX),2X,9(1HX),2X,3(1HX),4X,3(1HX),1X,10(1HX),1X,8(1HX),
     & 7X,3(1HX),5X,10(1HX),1X,8(1HX),3X,3(1HX),4X,3(1HX),2X,5(1HX))
C
C---- SIXTH LINE
   2  FORMAT(
     & 10X,8(1HX),3X,6(1HX),5X,3(1HX),4X,3(1HX),1X,10(1HX),1X,8(1HX),
     & 7X,3(1HX),5X,10(1HX),1X,8(1HX),3X,3(1HX),4X,3(1HX),4X,6(1HX)/
C---- SEVENTH LINE
     & 10X,3(1HX),8X,3(1HX),1X,3(1HX),4X,3(1HX),4X,3(1HX),1X,3(1HX),1
     & X,2(1HX),2(1X,3(1HX)),12X,3(1HX),5X,3(1HX),4X,3(1HX),1X,3(1HX)
     & ,8X,3(1HX),4X,3(1HX),8X,3(1HX)/
C---- EIGHTH LINE
     & 10X,3(1HX),8X,3(1HX),2X,3(1HX),3X,3(1HX),4X,3(1HX),1X,3(1HX),4X
     & ,3(1HX),1X,3(1HX),12X,3(1HX),5X,3(1HX),4X,3(1HX),1X,3(1HX),8X,3
     & (1HX),4X,3(1HX),8X,3(1HX)/
C---- NINETH LINE
     & 10X,3(1HX),8X,3(1HX),3X,3(1HX),3X,8(1HX),2X,3(1HX),4X,3(1HX),1
     & X,10(1HX),5X,3(1HX),5X,3(1HX),4X,3(1HX),1X,10(1HX),2X,8(1HX),2
     & X,9(1HX)/
C---- TENTH LINE
     & 10X,3(1HX),8X,3(1HX),4X,3(1HX),3X,6(1HX),3X,3(1HX),4X,3(1HX),1
     & X,10(1HX),5X,3(1HX),5X,3(1HX),4X,3(1HX),1X,10(1HX),3X,6(1HX),3
     & X,8(1HX),5(/))
C
C---- PRINT NOW     THE FIRE BEARING
C
C---- FIRST LINE
    3 FORMAT(21X,1HX,4X,1HX,18X,2(1HX),2X,1HX,18X,1HX,27X,1HX/
C---- SECOND LINE
     & 21X,1HX,4X,1HX,17X,1HX,23X,1HX/
C---- THIRD LINE
     & 19X,5(1HX),2X,4(1HX),4X,3(1HX),5X,5(1HX),2X,1HX,2X,1HX,1X,
     & 3(1HX),2X,3(1HX),6X,4(1HX),4X,3(1HX),4X,3(1HX),3X,1HX,1X,
     & 3(1HX),2X,1HX,2X,1HX,1X,2(1HX),4X,3(1HX)/
C---- FOURTH LINE
     & 21X,1HX,4X,1HX,3X,1HX,2X,1HX,3X,1HX,6X,1HX,4X,1HX,2X,2HXX,4X,
     & 1HX,3X,1HX,5X,1HX,3X,1HX,2X,1HX,3X,1HX,2X,1HX,2X,1HX,3X,2HXX,
     & 5X,1HX,2X,2(1HX),2X,1HX,2X,1HX,3X,1HX/
C---- FIFTH LINE
     & 21X,1HX,4X,1HX,3X,1HX,2X,5(1HX),6X,1HX,4X,1HX,2X,1HX,5X,5(1HX)
     & ,5X,1HX,3X,1HX,2X,5(1HX),2X,1HX,2X,1HX,3X,1HX,6X,1HX,2X,1HX,3X
     & ,1HX,2X,1HX,3X,1HX/
C---- SIXTH LINE
     & 21X,1HX,4X,1HX,3X,1HX,2X,1HX,10X,1HX,4X,1HX,2X,1HX,5X,1HX,9X,
     & 1HX,3X,1HX,2X,1HX,6X,1HX,2X,1HX,3X,1HX,6X,1HX,2X,1HX,3X,1HX,2X
     & ,1HX,3X,1HX/
C---  SEVENTH LINE
     & 21X,1HX,4X,1HX,3X,1HX,3X,4(1HX),6X,1HX,4X,1HX,2X,1HX,6X,4(1HX)
     & ,5X,4(1HX),4X,4(1HX),3X,4(1HX),2X,1HX,6X,1HX,2X,1HX,3X,1HX,3X,
     & 4(1HX)/
C--- EIGHTH AND NINETH LINE
     & 110X,1HX/106X,4(1HX),5(/))
C
C---- PRINT NOW    TITAN GOD
C
C---- FIRST LINE
    4 FORMAT(39X,5(1HX),2X,1HX,4X,1HX,21X,3(1HX),14X,1HX/
C---- SECOND LINE
     & 41X,1HX,9X,1HX,20X,1HX,17X,1HX/
C---- THIRD LINE
     & 41X,1HX,4X,1HX,2X,5(1HX),3X,3(1HX),3X,1HX,1X,3(1HX),4X,1HX,1X,
     & 3(1HX),3X,3(1HX),4X,4(1HX)/
C---- FOURTH LINE
     & 41X,1HX,4X,1HX,4X,1HX,4X,1HX,2X,1HX,3X,2(1HX),2X,1HX,4X,1HX,3X
     & ,1HX,2X,1HX,3X,1HX,2X,1HX,3X,1HX/
C---- FIFTH LINE
     & 41X,1HX,4X,1HX,4X,1HX,4X,1HX,2X,1HX,3X,1HX,3X,1HX,4X,1HX,3X,
     & 1HX,2X,1HX,3X,1HX,2X,1HX,3X,1HX/
C---- SIXTH LINE
     & 41X,1HX,4X,1HX,4X,1HX,4X,1HX,2X,1HX,3X,1HX,3X,1HX,4X,1HX,3X,
     & 1HX,2X,1HX,3X,1HX,2X,1HX,3X,1HX/
C---- SEVENTH LINE  (THANKS HEAVEN)
     & 41X,1HX,4X,1HX,4X,1HX,5X,4(1HX),2X,1HX,3X,1HX,5X,3(1HX),4X,
     & 3(1HX),4X,4(1HX),5(/))
C
C---- PRINT REST OF COVER
C
    5 FORMAT(38X,45HPROGRAM   SYSTEM FOR SOPHISTICATED STRUCTURE ,
     & 10HREFINEMENT,7(/),
C
C---- PRINT DATE OF LAST UPDATE
C
     & 52X,24HVERSION OF NOVEMBER 1980,7(/),
C
C---- AUTHORS
     & 32X,66HU.H. ZUCKER, E. PERENTHALER, W.F. KUHS, R. BACHMANN, AND H
     &. SCHULZ)
      RETURN
      END
                          SUBROUTINE SPACE
     &                  (N,IOV,IB,IO,MAXLIN)
C
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C +                                                                    +
C + SUBROUTINE SPACE PRINTS THE FIRST AND THE LAST LINE OF THE COVER   +
C + FOR EACH PROGRAM   AND POSITIONES THE TEXT BLOCK OF THE COVER      +
C + DEPENDING ON THE MAXIMUM NUMBER OF LINES PER PAGE (MAXLIN).        +
C + WRITTEN BY E. PERENTHALER  MPI-FKF (DECEMBER 1980)                 +
C +                                                                    +
C + THIS PROGRAM   IS CALLED BY EACH PROGRAM  OF THE SYSTEM            +
C + PROMETHEUS.                                                        +
C +                                                                    +
C + THIS PROGRAM   DO NOT CALL ANY OTHER SUBROUTINE.                   +
C +                                                                    +
C + IN CASE OF AN OVERLAY STRUCTURE IT IS PART OF THE MAIN-OVERLAY     +
C +                                                                    +
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C
C---- INPUT VARIABLES
C     ---------------
C
C   - N       FIRST OR SECOND CALL BY ONE OF THE PROGRAM  S
C             (BEGIN OR END OF THE COVER TO BE PRINTED)
C   - IOV     NUMBER OF THE CALLING PROGRAM
C   - IB      LENTH OF THE TEXT BLOCK ON THE COVER OF THIS PROGRAM
C
C---- DIMENSION STATEMENTS
C     --------------------
C
      DIMENSION IOVERL(14),IAY(14)
C
C---- DATA STATEMENTS
C     ---------------
C
C---- TABLE OF LEGAL OVERLAY NAMES
C
      DATA IOVERL/4HSPSC,4HTDSC,4HABSO,4HSPHE,4HAVER,4HREFI,4HFOUR,
     &4HERRM,4HPDFM,4HPOTC,4HARBS,4HPLOT,4HBONV,4HLIST/
C
      DATA IAY/2HAN,2HOR,2HRB,2HRE,2HAG,2HNE,2HIE,2HAP,2HAP,2HAL,2HEC,
     &2HTE,2HIB,2HFC/
C
C---- FORMAT STATEMENTS
C     -----------------
C
   10 FORMAT (1H1,3X,18(A4,A2,1X))
   40 FORMAT (1X)
   70 FORMAT (4X,18(A4,A2,1X))
C
C---- EXECUTABLE STATEMENTS
C     ---------------------
C
C---- BEGIN OR END OF THE COVER
      IF (N .EQ. 2) GO TO 20
C
C---- FIRST LINE OF THE COVER
      WRITE (IO,10) (IOVERL(IOV),IAY(IOV),I=1,18)
C
C---- NUMBER OF EMPTY LINES TILL START OF TEXT BLOCK
   20 IS = MAXLIN / 3
      IF (MAXLIN - IS - IB - 4 .LT. 4) IS = MAXLIN - IB - 8
C
C---- BEGIN OR END OF THE COVER
      IF (N .EQ. 2) GO TO 50
C
C---- EMPTY LINES
      DO 42 I=1,IS
42    WRITE (IO,40)
C
      RETURN
C
C---- NUMBER OF EMPTY LINES BEHIND THE TEXT BLOCK
   50 IS = MAXLIN - IS - IB - 4
C
C---- EMPTY LINES
      DO 43 I=1,IS
43    WRITE (IO,40)
C
C---- LAST LINE OF THE COVER
      WRITE (IO,70) (IOVERL(IOV),IAY(IOV),I=1,18)
C
      RETURN
      END
C     OVERLAY (MAI,2,0)
C     PROGRAM FOURIE (TAPE1,TAPE2,EINGABE,OUTPUT,TAPE5=EINGABE,
C    &TAPE6=OUTPUT,TAPE10,TAPE13)
      SUBROUTINE FOURIE
C
C       GENERALIZED FOURIER PROGRAM   MAY 1974   BY L. W. FINGER
C
C      MODIFICATIONS MADE BY U. ZUCKER MPI/FKF (OKT. 78 - SEP. 79)
C      -----------------------------------------------------------
C
C            -CONTROL OF THE DIMENSION OF THE ARRAY "ARRAY"
C     -POINT-ARRAY PRINTING WITH  VARIABLE  OUTPUT  FORMAT  DUE TO
C                          LATTICE ANGLES.
C    -REJECT ROUTINES FOR SPECIAL HKL-VALUES OR SIN(THETA)/LAMBDA
C                               RANGES.
C    -AUTOMATICALLY  TRANSFORMATIONS  TO  MAKE  ALWAYS SURE, THAT
C                 INPUT CORRESPONDS TO XYZ-SYSTEM.
C
C  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C  +++                   CORE ALLOCATION                      +++
C  +++                                                        +++
                      DIMENSION ARRAY(40000)
C  +++                                                        +++
C  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      DIMENSION IFBUF(505),FBUF(504),IARRAY(1),WINKEL(3)
      DIMENSION TITLE(18),JH(3),IH(3),IP(43),RMAT(3,3,24),IRMAT(3,
     13,24),TRANS(3,24),IEXTR(6),FX(21),FMULT(12),TITEL(3),KURS(18)
     &,CELL(6),IHKL(100),JHKL(100),KHKL(100),RECELL(6),HK(3)
C
      INTEGER OUT,S1,ZRO,ENDD,S2,FRMT(50),IU(50),LABEL(20)
C
      EQUIVALENCE(WINKEL(1),ALF),(WINKEL(2),BET),(WINKEL(3),GAM)
      EQUIVALENCE (IEXTR(1),IBX),(IEXTR(2),IBY),(IEXTR(3),IBZ)
      EQUIVALENCE (IEXTR(4),IMAX),(IEXTR(5),KMAX),(IEXTR(6),LMAX)
      EQUIVALENCE (FBUF,IFBUF),(IFBUF(505),ARRAY(1),IARRAY(1))
      EQUIVALENCE (RMAT,IRMAT),(FX,IP)
C
      DATA FRMT/4H(A1,,4HF4.0,3H,1X,47*1H /
      DATA IU/3H,1X,3H,2X,3H,3X,3H,4X,3H,5X,3H,6X,3H,7X,3H,8X,
     & 3H,9X,4H,10X,4H,11X,4H,12X,4H,13X,4H,14X,4H,15X,4H,16X,4H,17X,
     &4H,18X,4H,19X,4H,20X,4H,21X,4H,22X,4H,23X,4H,24X,4H,25X,4H,26X,
     &4H,27X,4H,28X,4H,29X,4H,30X,4H,31X,4H,32X,4H,33X,4H,34X,4H,35X,
     &4H,36X,4H,37X,4H,38X,4H,39X,4H,40X,4H,41X,4H,42X,4H,43X,4H,44X,
     &4H,45X,4H,46X,4H,47X,4H,48X,4H,49X,4H,50X/
      DATA LABEL/1H ,4HDIFF,3HXYZ,3HXZY,3HYXZ,3HYZX,3HZYX,3HZXY,
     1 3HH00,3H00L,3HHK0,3HH0L,3H0KL,3HHH0,3HH0H,3H0KK,3HHHH,3HHHL,3HHKK
     2,3HHKL/
      DATA IN,OUT,S1,ZRO,NZRO,ENDD,S2/5,6,13,3H,4X,3H,I4,1H),11/
      DATA TWOPI,ISPC,IBNK,IS1/6.2831853,1H0,1H ,0/
      DATA IEND/3HEND/
      DATA LEER/1H /
C
    2 FORMAT(18A4/8I3)
    3 FORMAT(1H1,//14H PROGRAM TITEL/1X,13(1H-)//1X,18A4,////,16H TITLE
     &OF CYCLE  /1X,14(1H-)//1X,18A4,////,15H CELL CONSTANTS/1X,14(1H-),
     &//27X,3(F10.4,2X),15H     ANGSTROEMS //27X,3(F10.4,2X),12H    DEGR
     &EES ////,14H STARTING TIME/1X,13(1H-)//)
    4 FORMAT(7I1,1X,9I4,2F8.0,A4)
    5 FORMAT(18H0PROGRAM-BREAKDOWN/1X,17(1H!)//28H YOU WANT TO READ MORE
     & THAN ,I5,14H  REFLECTIONS./80H0TO DO THIS, YOU HAVE TO INCREASE T
     &HE DIMENSION OF THE ARRAY "ARRAY" TO AT LEAST/ 34H03*(NUMBER OF RE
     &FLECTIONS) +1000 . /19H0MAYBE IT'S ENOUGH!  )
    6 FORMAT(A1,F4.0)
    8 FORMAT(1H1,18A4,16X,7HSECTION,I4,1H/,I4//F10.0,14F8.0)
   12 FORMAT(/5X,24HALL REFLECTIONS INCLUDED     )
   13 FORMAT(/5X,46HREFLECTIONS WITH REJ. FLAG SET NOT INCLUDED   )
   14 FORMAT(//5X,A4,8H FOURIER,10X,A3,9H SECTIONS//5X,9HF(000) = ,
     1F10.3//5X,19HMAP EXAGGERATION = ,F10.3//5X,31HMULTIPLICITY OF GEN
     2ERAL REFL = ,F10.3)
   15 FORMAT(//15H MULTIPLICITIES/1X,14(1H-)//5X,11(A3,5X),A3//12F8.2///
     & )
   16 FORMAT(//31H GRIDPOINT- AND HKL- INTERVALS  /1X,30(1H-)//
     & 9X,50HINITIAL   FINAL    INTERVAL   MIN INDEX  MAX INDEX
     &,10H POINTS   ,I4,I8,I12,I10,I11/8H LINES  ,I6,I8,I12,I10,I11
     1/9H SECTIONS,I5,I8,I12,I10,I11)
   17 FORMAT(/5X,34HSECTIONS SAVED FOR LATER PLOTTING.)
   18 FORMAT(//12H MEMORY USED/1X,11(1H-)//30H DIMENSION OF THE FIELD AR
     &RAY ,I6,5H  OF ,I6)
   19 FORMAT(1H+,35X,A3,9H SECTIONS//5X,9HF(000) = ,
     & F10.3//5X,19HMAP EXAGGERATION = ,F10.3//5X,31HMULTIPLICITY OF GEN
     2ERAL REFL = ,F10.3)
   20 FORMAT(//16H ATOM COORDINATS/1X,15(1H-)//
     &       ,15X,18HFRACTIONAL COORDS.,11X,11HMAP COORDS./5H ATOM,8X,1H
     1X,8X,1HY,8X,1HZ,9X,5HPOINT,4X,4HLINE,3X,7HSECTION/)
   21 FORMAT(/17H0INPUT PARAMETERS/1X,16(1H-)//)
   22 FORMAT(1X,2A3,1X,3F9.5,3X,3F8.2)
   51 FORMAT(//5X,39HSHEER ANGLE APPROXIMATED IN OUTPUT =   ,I3 )
   52 FORMAT(//5X,40HFOBS AND FCALC CORRECTED FOR EXTINCTION  )
  240 FORMAT(///////, 43X,31H KENNZEICHEN DER UNIT MAIN  =     ,3A4,
     &10(/),35X, 9HSUBSTANZ=,15X,11HTEMPERATUR=,15X,10HSONSTIGES=  ,
     &14(/),3X,18(7HFOURIE ))
 1111 FORMAT(1H1,3X,18(7HFOURIE ),22(/),23X,
     &                    88H PROGRAMM FOR CALCULATION OF ELECTRON AND
     &DIFFERENCE ELECTRON DENSITIES  BY L.W. FINGER  //
     &40X,50H        MODIFIED    BY  U.ZUCKER (MPI FKF)        ///
     &40X,50H THIS PROGRAM  READS THE  FOURIER FILE CREATED  BY/
     &40X,50H THE PROGRAM REFINE. FROM THE  INEQUIVATENT STRUC-/
     &40X,50H TURE AMPLITUDES THE CHARGE DENSITY OF THE ELECTR-/
     &40X,50H NS IS CALCULATED.  FOUREIER,   DIFFERENCE FOURIER/
     &40X,50H AND PATTERSON SYNTHESES CAN BE CALCULATED.       /
     &40X,50H INFORMATIONS  ABOUT  THIS  PROGRAM  ARE AVAILABLE/
     &40X, 9H FROM,                                            )
 4711 FORMAT(1H1,28HFINALLY INCLUDED REFLECTIONS/1X,28(1H-)//,
     &  2X,1HH,4X,1HK,4X,1HL,11X,4HFOBS,7X,5HFCALC,6X,5HACALC
     &  ,6X,5HBCALC,10X,5HPHASE ///)
 4716 FORMAT(26H0FOURIERSYNTHESE( FCALC )  )
 4717 FORMAT(26H0PATTERSON - SYNTHESE      )
 4718 FORMAT(1H1,//,2X,1HH,4X,1HK,4X,1HL,11X,4HFOBS,7X,5HFCALC,
     & 6X,5HACALC,6X,5HBCALC,10X,5HPHASE//)
 4722 FORMAT(2F8.5,I3)
 4723 FORMAT(A3,10X,3I3)
 4739 FORMAT(17H0REJECT-PARAMETER/1X,16(1H-)//)
 4743 FORMAT(/51HONLY REFLECTIONS IN THE SIN(THETA)/LAMBDA INTERVALL ,
     & F7.2,2X,4HTILL,F7.2,5X,13HARE INCLUDED.  )
 4744 FORMAT(/53HONLY REFLECTIONS IN THE SIN(THETA)/LAMBDA INTERVALLS ,
     &   F5.2,2X,4HTILL,F5.2,2X,3HAND,F5.2,2X,4HTILL,F5.2,3X,13HARE INCL
     &UDED.  )
 4745 FORMAT(45HONLYTHE FOLLOWING REFLECTIONS ARE SELECTED.
     &   / 5(15HH    K    L    ))
 4748 FORMAT(5(3I4)/)
                           NRM1=40000
C  +++                                                        +++
C
C**** INITIALISE
C
      IPRINT=0
      INTEX=1
      IEXTCO=0
      SIMIN=2.0
      SIMAX=0.0
      NPAGE= 5
C *** IM GEDRUCKTEN POINT ARRAY WERDEN ALLE WERTE ZWISCHEN IMINI &
C   * IMAXI DURCH EIN BLANK ERSETZT.
  100 READ(IN,2,END=900)TITLE,ISELECT,ISTAT,IFILE,IAUSG,IPAT,IPART
     & ,IMINI,IMAXI
C *** IPAT.NE.0 >> PATTERSON. KEINE EINSCHRAENK. DER REFLEXE MOEGL.
      IF(IPAT.NE.0) IPART=0
C *** KEIN PATTE.>> EINSCHRAENK. DER REFL. NACH HKL ODER THETA MOEGL.
      IF(IPART)4719,4720,4721
C *** EINSCHRAENK. NACH SIN(THETA)/LAMBDA
 4719 READ(IN,4722)SINMIN,SINMAX,IMORE
      IF(IMORE.NE.0) READ(IN,4722)SIMIN,SIMAX
      GOTO 4720
C *** EINSCHRAENK. DER HKL-WERTE
 4721 READ(IN,4723)IMEHR,IHKL(INTEX),JHKL(INTEX),KHKL(INTEX)
      INTEX=INTEX+1
      IF(IMEHR.NE.IEND)GOTO 4721
C *** AENDERUNG DER EIN- UND AUSGABE UNITS
 4720 IF(IAUSG.NE.IS1)S2=IAUSG
      IF(IFILE.NE.IS1)S1=IFILE
C *** PATTERSON GEWAEHLT? DANN NACH 99 DA FOURFILE ERST ANGELEGT WIRD
      IF(IPAT.NE.0) GOTO 99
C *** NEIN. LIES FOURIERFILE DES REFINEPROGRAMMS
 2001 REWIND S1
      READ(S1)TITEL,KURS,WINKEL,AG,BG,CG
C *** DECKBLATT SCHON GEDRUCKT? JA,DANN 49
   99 IF(IPRINT.NE.0)GOTO 49
      WRITE(OUT,1111)
      IPRINT=1
C *** WENN PATTERSON, DANN SUBROUTINE PATSON.
      IF(IPAT.NE.0) CALL PATSON(S1)
      IF(IPAT.NE.0) GOTO 2001
      WRITE(OUT,240)TITEL
   49 WRITE(OUT,3)TITLE,KURS,AG,BG,CG,ALF,BET,GAM
C *** DRUCKE STARTZEIT DES PROGRAMMS
C
C *** READ SYMMETRY OPERATIONS FROM FOURIER FILE
      READ(S1)NSYM,VOL,(((RMAT(I,J,K),I=1,3),J=1,3),K=1,NSYM),((TRANS(J,
     1 I),J=1,3),I=1,NSYM),RECELL
      NFBR=504
C**** READ MAIN CONTROL CARD
      READ(IN,4)ITYPE,ISECT,ICENT,KREJ,IPLT,LSPC,NPNT,IX,IXI,IXF,IY,IYI,
     &IYF,IZ,IZI,IZF,EXXAG,FOOO,IWAHL
C**** FOBS CORRECTED FOR EXTINCTION ?
      IF(ITYPE.LE.3) GOTO 62
      IEXTCO=1
      ITYPE=ITYPE-4
C
C *** CALCULATION OR READING OF MULTIPLICITIES.
   62 CALL REFMUL(RMAT,NSYM,IWAHL,IN,FMULT)
C
      CALL ACHSE(ISECT,IX,IXI,IXF,IY,IYI,IYF,IZ,IZI,IZF)
      IF(ITYPE.EQ.1)    FOOO=0.
      IF(IPAT.NE.0)  ITYPE=3
C     VORBEREITUNG DER GITTERDATEN FUER ARB SECTION-PROGRAMM
      IF(IPLT.EQ.0)GOTO 4714
      CALL ARB(ISECT,CELL,ALF,BET,GAM,AG,BG,CG,JACHS)
      REWIND S2
      WRITE(S2)TITEL,TITLE,CELL,JACHS
 4714 WRITE(OUT,21)
      IF(ITYPE.GE.2) GOTO 4715
      WRITE(OUT,14)LABEL(ITYPE+1),LABEL(ISECT+3),FOOO,EXXAG,FMULT(12)
 4715 IF(ITYPE.EQ.2)WRITE(OUT,4716)
      IF(ITYPE.EQ.3)WRITE(OUT,4717)
      IF(ITYPE.GE.2)WRITE(OUT,19)LABEL(ISECT+3),FOOO,EXXAG,FMULT(12)
      IF(IPLT.GT.0)WRITE(OUT,17)
      IF(ISELECT-1)61,50,50
   50 WRITE(OUT,51)ISELECT
   61 IF(IEXTCO.EQ.1)WRITE(OUT,52)
      IF(KREJ)101,102,101
  101 WRITE(OUT,13)
      GO TO 103
  102 WRITE(OUT,12)
  103 IF(IPART.NE.0)WRITE(OUT,4739)
      IF(IPART)4740,4741,4742
 4740 IF(IMORE.EQ.0)WRITE(OUT,4743)SINMIN,SINMAX
      IF(IMORE.NE.0)WRITE(OUT,4744)SINMIN,SINMAX,SIMIN,SIMAX
      GOTO 4741
 4742 WRITE(OUT,4745)
      DO 4747 I=1,INTEX-1
 4747 WRITE(OUT,4748)IHKL(I),JHKL(I),KHKL(I)
 4741 CONTINUE
      WRITE(OUT,15)(LABEL(I),I=9,20),FMULT
      IF(ISTAT.EQ.0) GO TO 4713
      WRITE(OUT,4711)
 4713 FOOO=FOOO*EXXAG/VOL
      EXXAG=2.0*EXXAG/(VOL*FMULT(12))
C        TRANSFORM AND CONVERT SYMMETRY OPERATORS
                             DO 113 I=1,NSYM
                             DO 113 J=1,3
      TRANS(J,I)=TWOPI*TRANS(J,I)
C
C---- IN CASE OF A PATTERSON SYNTHESIS NO TRANSLATION VECTOR LEGAL.
C
      IF(ITYPE.EQ.3) TRANS(J,I) = 0.0
                             DO 112 K=1,3
  112 IH(K)=RMAT(J,K,I)
      CALL SECT(ISECT,IH)
                             DO 113 K=1,3
  113 IRMAT(J,K,I)=IH(K)
C *** MAXRFL=MAXIMALZAHL DER REFLEXE + UEBERHANG ENTSPRECHEND
C     EINER MITTLEREN GRIDPOINT ANZAHL.
      MAXRFL=INT((NRM1-1000)/3)-1
      DO 120 I=1,6
  120 IEXTR(I)=0
      INDEX=1
      NREFL=0
      NFBR=1000
      LSPCH=LSPC
      IF(LSPC.NE.0)GO TO 125
C        DOUBLE SPACE THE MAP
      LSPC=ISPC
      GO TO 130
C        SINGLE SPACE THE MAP
  125 LSPC=IBNK
C
C**** READ REFLECTION DATA
C     NFBR+  1  2  3    4     5    6  7   8     9     10
C         =  H  K  L   FOBS FCALC  A  B  NREJ  SIGF  EXY
  130 NFBR=NFBR+10
      IF(NFBR-500)150,140,140
C        GET NEW BLOCK
  140 READ(S1)(FBUF(I),I=1,504)
      NFBR=0
  150 IH(1)=IFBUF(NFBR+1)
      IH(2)=IFBUF(NFBR+2)
      IH(3)=IFBUF(NFBR+3)
      FOBS=FBUF(NFBR+4)
C**** EXTINCTION CORRECTION
      IF(IH(1)-99)160,600,160
160   IF(IEXTCO.EQ.0) GOTO 151
      FOBS=FOBS/SQRT(FBUF(NFBR+10))
      FBUF(NFBR+5)=FBUF(NFBR+5)/SQRT(FBUF(NFBR+10))
151   CONTINUE
C        NOT END, CHECK IF REJECTED
      IF(IFBUF(NFBR+8))170,180,170
  170 IF(KREJ)130,180,130
C        REFLECTION NOT REJECTED
  180 IF(IPART)4730,4180,4731
 4730 RHO=0.
      DO 4732 K=1,3
      HK(K)=FLOAT(IH(K))*RECELL(K)
 4732 RHO=RHO+HK(K)**2
      RHO=(RHO+2.0*(HK(1)*HK(2)*RECELL(6)+HK(1)*HK(3)*RECELL(5)+HK(2)*HK
     & (3)*RECELL(4)))*0.25
      RHO=SQRT(RHO)
      IF(RHO.GT.SINMIN.AND.RHO.LT.SINMAX) GOTO 4180
      IF(IMORE.NE.0.AND.RHO.GT.SIMIN.AND.RHO.LT.SIMAX)  GOTO 4180
      GOTO 130
 4731 DO 4733 IIK=1,INTEX-1
 4733 IF( IHKL(IIK).EQ.IH(1) .AND. JHKL(IIK).EQ.IH(2) .AND. KHKL(IIK)
     & .EQ.IH(3) ) GOTO 4180
      GOTO 130
 4180 NREFL=NREFL+1
      IF(NREFL-MAXRFL)200,200,190
  190 WRITE(OUT,5)NREFL
      GOTO 900
  200 INDEX=INDEX+3
      GOTO (220,210,211,212),ITYPE+1
  211 FOBS=FBUF(NFBR+5)
      GOTO 220
  212 FOBS=FOBS**2
      FBUF(NFBR+7)=0.0
      ARRAY(INDEX-1)=0.0
      GOTO 213
  210 FOBS=FOBS-FBUF(NFBR+5)
C        CALCULATE PHASE ANGLE
  220 IF(ICENT)230,225,230
  225 FBUF(NFBR+7)=0.0
  230 ARRAY(INDEX-1)=ATAN2(FBUF(NFBR+7),FBUF(NFBR+6))
C             DETERMINE REFLECTION TYPE
  213 IF(IH(1))350,280,350
  280 IF(IH(2))300,290,300
C             00L REFLECTION
  290 IC=2
      GO TO 530
  300 IF(IH(3))320,310,320
C             0K0 REFLECTION
  310 IC=1
      GO TO 530
  320 IF(IH(2)-IH(3))340,330,340
C             0KK REFLECTION
  330 IC=8
      GO TO 530
C             0KL REFLECTION
  340 IC=5
      GO TO 530
  350 IF(IH(2))410,360,410
  360 IF(IH(3))380,370,380
C             H00 REFLECTION
  370 IC=1
      GO TO 530
  380 IF(IH(1)-IH(3))400,390,400
C             H0H REFLECTION
  390 IC=7
      GO TO 530
C             H0L REFLECTION
  400 IC=4
      GO TO 530
  410 IF(IH(3))450,420,450
  420 IF(IH(1)-IH(2))440,430,440
C             HH0 REFLECTION
  430 IC=6
      GO TO 530
C             HK0 REFLECTION
  440 IC=3
      GO TO 530
  450 IF(IH(1)-IH(2))490,460,490
  460 IF(IH(1)-IH(3))480,470,480
C             HHH REFLECTION
  470 IC=9
      GO TO 530
C             HHL REFLECTION
  480 IC=10
      GO TO 530
  490 IF(IH(2)-IH(3))510,500,510
C             HKK OR HKH REFLECTION
  500 IC=11
      GO TO 530
  510 IF(IH(1)-IH(3))520,500,520
C             HKL REFLECTION
  520 IC=12
  530 ARRAY(INDEX-2)=EXXAG*FMULT(IC)*FOBS
      IARRAY(INDEX-3)=(IH(1)*256+IH(2))*256+IH(3)+6579300
C        EXPAND INDEX LIST
      DO 590 I=1,NSYM
      DO 540 J=1,3
      JH(J)=0.0
      DO 540 K=1,3
  540 JH(J)=JH(J)+IRMAT(K,J,I)*IH(K)
      DO 590 J=1,3
      IF(JH(J)-IEXTR(J))570,570,560
C        SET NEW MAXIMUM
  560 IEXTR(J)=JH(J)
      GO TO 590
  570 IF(JH(J)-IEXTR(J+3))580,590,590
C        SET NEW MINIMUM
  580 IEXTR(J+3)=JH(J)
  590 CONTINUE
C *** SCHREIBE DIEJENIGEN REFLEXE AUF, DIE IN DIE BERECHNUNG EINGE-
C   * SCHLOSSEN WURDEN.
      IF(ISTAT.EQ.0)GO TO 6001
      IF(NPAGE.NE.64) GOTO 4724
      WRITE(OUT,4718)

      NPAGE=0
 4724 NPAGE=NPAGE+1
 4712 FORMAT(3(I3,2X),4X,4(F10.3,2X),4X,F10.3)
      WRITE(06,4712)(IFBUF(NFBR+IT),IT=1,3) ,(FBUF(NFBR+IT),IT=4,7)
     &   , ARRAY(INDEX-1)*57.29578
C
 6001 GO TO 130
C        END OF REFLECTION LIST
  600 IARRAY(INDEX)=0
C        MOVE REFLECTION DATA TO START OF BUFFER AREA
      DO 610 I=1,INDEX
  610 FBUF(I)=ARRAY(I)
      IPN1=INDEX
      IF(ISTAT.NE.0)WRITE(OUT,4725)
 4725 FORMAT(1H1)
      WRITE(OUT,16)IXI,IXF,IX,IEXTR(4),IBX,IYI,IYF,IY,IEXTR(5),IBY,
     $IZI,IZF,IZ,IEXTR(6),IBZ
      XX=TWOPI/FLOAT(IX)
      YY=TWOPI/FLOAT(IY)
      ZZ=TWOPI/FLOAT(IZ)
      IXA=IXF-IXI+1
      IYA=IYF-IYI+1
      IZA=IZF-IZI+1
      DO 620 I=1,3
      IEXTR(I+3)=MAX0(IEXTR(I),-IEXTR(I+3))
  620 IEXTR(I)=2*IEXTR(I+3)+1
      IBX=IMAX+1
      IPN2=IPN1+IBX*IBY
      IPN3=IPN2+IBX*IBY
      IPN4=IPN3+IMAX*IXA
      IPN5=IPN4+IMAX*IXA
      I=MAX0(KMAX,IBZ)
      IPN6=IPN5+I
      IPN7=IPN6+I
      IPN8=IPN7+IBX
      IPN9=IPN8+IBX
      IPN10=IPN9
      IF(IPLT.EQ.0)GO TO 621
C        SECTIONS TO BE SAVED FOR PLOTTING
      IPN10=IPN9+IXA*IYA
  621 IPN10=MAX0(IPN10,IPN1+1020)
      WRITE(OUT,18)IPN10,NRM1
      IF (IPN10-NRM1.GE.0) GOTO 910
C  READ ATOM PARAMETERS FROM THE FILE
      READ(S1,END=625)NATOM,((FBUF(IPN1+17*I+J-17),J=1,17),I=1,NATOM)
      WRITE(OUT,20)
      J=IPN1-17
      DO 623 I=1,NATOM
      J=J+17
      DO 622 K=1,3
  622 FX(K)=FBUF(J+K+8)
C        TRANSFORM ATOM COORDINATES TO MAP SYSTEM
      CALL SECTR(ISECT,FX)
      FX(1)=FX(1)*IX
      FX(2)=FX(2)*IY
      FX(3)=FX(3)*IZ
C        PRINT BOTH ORIGINAL AND TRANSFORMED COORDINATES
  623 WRITE(OUT,22)(FBUF(J+K),K=1,2),(FBUF(J+K),K=9,11),(FX(K),K=1,3)
C *** WINKELZUWEISUNG ENTSPRECHEND DEM GEWAEHLTEN SCHNITT (FALLS OUT-
C   * GEWUENSCHT IST.)
 625  IF(NPNT.NE.0) GOTO 632
      IF(ISELECT.GE.2)GAM=FLOAT(ISELECT)
      IF(ISELECT.GE.2)GO TO 6003
      IF(ISECT.EQ.1.OR.ISECT.EQ.5)GAM=BET
      IF(ISECT.EQ.3.OR.ISECT.EQ.4)GAM=ALF
 6003 IF(GAM.LE.30..OR.GAM.GE.160)GAM=90.
      IF (GAM-90.0) 1003,1002,1001
 1002 IS=0
      GO TO 624
 1001 HILF=GAM-90.0
      IS=1
 1005 IF(LSPCH.NE.0)DEL=30.0
      IF(LSPCH.EQ.0)DEL=15.0
      HILF=HILF/DEL
      IHILF=INT(HILF)
      DIF=HILF-FLOAT(IHILF)
      IF (DIF.GE.0.5) IHILF=IHILF+1
      IF(IHILF.EQ.0)IS=0
      GOTO 624
 1003 HILF=ABS(GAM-90)
      IS=-1
      GO TO 1005
  624 WRITE(OUT,631)GAM,IHILF,IMINI,IMAXI
  631 FORMAT(///22H POINT-ARRAY PARAMETER/1X,21(1H-)//44H DER ZU ZEICHNE
     &NDE  SCHERUNGSWINKEL BETRAEGT,F8.1,3X,5HGRAD./43H ER WIRD DURCH EI
     &NE ZEILENVERSCHIEBUNG VON ,I2,35H LEERSTELLEN PRO ZEILE ANGENAEHER
     &T.//58H IM DEN GEDRUCKTEN POINT-ARRAYS WERDEN ALLE WERTE ZWISCHEN,
     &I4,5H  UND,I4,15H  UNTERDRUECKT.  )
  632 K=IPN3
      L=IPN4
      DO 630 I=1,IXA
      HY=XX*FLOAT(I+IXI-1)
      DO 630 J=1,IMAX
      HX=HY*FLOAT(J)
      K=K+1
      L=L+1
      FBUF(K)=COS(HX)
  630 FBUF(L)=SIN(HX)
C        START SECTION LOOP
      DO 890 IZC=1,IZA
      J=IZC+IZI-1
C        PRECALCULATE COS AND SIN 2 PI L Z
      HY=ZZ*FLOAT(J)
      DO 650 I=1,IBZ
      HX=HY*FLOAT(I-LMAX-1)
      FBUF(IPN5+I)=COS(HX)
  650 FBUF(IPN6+I)=SIN(HX)
C        INITIALIZE SECTION ARRAYS
      J=IPN1+1
      DO 660 I=J,IPN3
  660 FBUF(I)=0.0
      FBUF(IPN1+KMAX+1)=FOOO
C        LOOP THROUGH REFLECTION LIST
      INDEX=-2
  700 INDEX=INDEX+3
      IF(IFBUF(INDEX))710,770,710
C        UNPACK INDICES
  710 IH(2)=IFBUF(INDEX)/256
      IH(3)=IFBUF(INDEX)-IH(2)*256-100
      IH(1)=IH(2)/256
      IH(2)=IH(2)-256*IH(1)-100
      IH(1)=IH(1)-100
C        LOOP THROUGH SYMMETRY OPERATIONS
      DO 760 I=1,NSYM
      HX=FBUF(INDEX+2)
      DO 720 J=1,3
      HX=HX-IH(J)*TRANS(J,I)
      JH(J)=0
      DO 720 K=1,3
  720 JH(J)=JH(J)+IRMAT(K,J,I)*IH(K)
      IF(JH(1))730,750,750
C        TRANSFORMED H.LT.0, CHANGE REFLECTION TO FRIEDEL EQUIV.
  730 DO 740 J=1,3
  740 JH(J)=-JH(J)
      HX=-HX
  750 J=JH(1)*IBY+JH(2)+KMAX+1
      K=JH(3)+LMAX+1
      FSS=FBUF(INDEX+1)*SIN(HX)
      FCC=FBUF(INDEX+1)*COS(HX)
      FBUF(IPN1+J)=FBUF(IPN1+J)+FCC*FBUF(K+IPN5)+FSS*FBUF(K+IPN6)
  760 FBUF(IPN2+J)=FBUF(IPN2+J)+FSS*FBUF(K+IPN5)-FCC*FBUF(K+IPN6)
      GO TO 700
C        ALL REFLECTIONS SUMMED, REARRANGE SECTION SUMS
  770 DO 780 I=1,IBX
      K=IBY*(I-1)+KMAX+1
      L=K
      DO 780 J=1,KMAX
      K=K+1
      L=L-1
      HX=FBUF(IPN1+K)
      HY=FBUF(IPN1+L)
      FBUF(IPN1+K)=HX+HY
      FBUF(IPN1+L)=HY-HX
      HX=FBUF(IPN2+K)
      HY=FBUF(IPN2+L)
      FBUF(IPN2+K)=HX+HY
  780 FBUF(IPN2+L)=HX-HY
C        START LOOP THROUGH STRIPS ALONG X
      DO 880 IXZ=1,IXA,30
      IXX=IXZ+IXI-1
      NXA=MIN0(30,IXF-IXX+1)
      NX=0
      DO 782 I=1,NXA,2
      NX=NX+1
  782 FX(NX)=I+IXX-1
      J=IZC+IZI-1
      IF(NPNT.EQ.0)WRITE(OUT,8)TITLE,J,IZ,(FX(I),I=1,NX)
C        START LOOP FOR LINES
      DO 880 IAJ=1,IYA
      IPSV=(IAJ-1)*IXA+IXX-IXI+IPN9
      FY=IAJ+IYI-1
      HY=YY*FY
      DO 785 I=1,KMAX
      HX=HY*FLOAT(I)
      FBUF(IPN5+I)=COS(HX)
  785 FBUF(IPN6+I)=SIN(HX)
C        LOOP OVER VALUES OF H
      DO 790 I=1,IBX
      K=IBY*(I-1)+KMAX+1
      L=K
      M=IPN7+I
      N=IPN8+I
      FBUF(M)=FBUF(K+IPN1)
      FBUF(N)=FBUF(K+IPN2)
C        SUM OVER K
      DO 790 J=1,KMAX
      K=K+1
      L=L-1
      FBUF(M)=FBUF(M)+FBUF(IPN1+K)*FBUF(J+IPN5)+FBUF(L+IPN2)*FBUF(J+IPN6
     1)
  790 FBUF(N)=FBUF(N)+FBUF(IPN2+K)*FBUF(J+IPN5)+FBUF(IPN1+L)*FBUF(J+IPN6
     1)
C        START POINTS LOOP
      L=0
      K=(IXX-IXI)*IMAX
      DO 870 I=1,NXA
      HX=FBUF(IPN7+1)
C        SUM OVER H
      DO 800 J=1,IMAX
      K=K+1
  800 HX=HX+FBUF(IPN7+J+1)*FBUF(IPN3+K)+FBUF(IPN8+J+1)*FBUF(IPN4+K)
C        MAP POINT CALCULATED, CONVERT FOR PRINTING AND ADD TO PLOT OUTP
      IF(IPLT.EQ.0)GO TO 805
      IPSV=IPSV+1
      FBUF(IPSV)=HX
  805 IF(NPNT.NE.0) GOTO 870
      J=HX+SIGN(.5,HX)
      IF(J) 810,860,830
  810 IF(J+1000)820,820,850
  820 J=J+1000
      GO TO 810
  830 IF(J-10000)850,840,840
  840 J=J-10000
      GO TO 830
  850 IF(J.GT.IMINI.AND.J.LT.IMAXI) GOTO 860
      L=L+1
      IP(L)=J
      FRMT(I+3)=NZRO
      GO TO 870
  860 FRMT(I+3)=ZRO
  870 CONTINUE
      IF(NPNT.NE.0)GOTO 880
  876 FRMT(NXA+4)=ENDD
C
C *** PRINT LINE, FALLS NPNT=0 IST.
C *** ENTSRECHEND DEM WINKEL GAM WIRD FRMT TRANSFORMIERT
      IF(IS)1021,1022,1023
 1021 LSTORE=L
      ICHECK=(IAJ-1)*IHILF+1
      FRMT(3)=IU(ICHECK)
      ICHECK=INT(ICHECK/4)+1
      IF(ICHECK+NXA-30)1043,1043,1042
 1042 DO 1071 IO=34-ICHECK,3+NXA
      IF(FRMT(IO).EQ.NZRO)L=L-1
 1071 FRMT(IO)=LEER
 1043 IF(L.EQ.0) GO TO 872
      WRITE(OUT,FRMT)LSPC,FY,(IP(I),I=1,L)
      GO TO 880
 1022 FRMT(3)=IU(1)
      GOTO 877
 1023 IF(IAJ.EQ.1)GO TO 1050
      IF(LUECK.EQ.0)ISTART=ISTART+1
      LUECK=MOD(4+LUECK-IHILF,4)
      FRMT(3)=IU(1+LUECK)
      ICOR=0
      IF(ISTAR.GT.NXA)GOTO 880
      DO 1054 IKLJ=1,ISTART-1
      IF(FRMT(3+IKLJ).EQ.NZRO)ICOR=ICOR+1
 1054 FRMT(3+IKLJ)=LEER
      ISTAR=ICOR+1
 1045 IF(L.EQ.0) GO TO 872
      WRITE(OUT,FRMT)LSPC,FY,(IP(I),I=ISTAR,L)
      GO TO 880
 1050 ISTART=1
      LUECK=0
      ISTAR=1
      FRMT(3)=IU(1)
      GOTO 1045
 877  IF(L.EQ.0)  GO TO 872
      WRITE(OUT,FRMT)LSPC,FY,(IP(I),I=1,L)
 880  CONTINUE
C        SECTION NOW COMPLETE - DUMP PLOT OUTPUT IF NEEDED
 881  IF(IPLT.EQ.0)GO TO 890
      J=IZC+IZI-1
      WRITE(S2)IXA,IYA,J,IZ,IX,IXI,IXF,IY,IYI,IYF,IZI,IZF
      J=IPN9+1
      WRITE(S2)(FBUF(I),I=J,IPN10)
  890 CONTINUE
C        END OF MAP, GO GET DATA FOR NEXT ONE
C     GO TO 100
  900 RETURN
C *** AN DIESE STELLE WIRD GESPRUNGEN, WENN EINE ZEILE DES POINT-ARRAYS
C   * NUR AUS NULLEN BESTEHEN SOLLTE.
  872 WRITE(OUT,6)LSPC,FY
      GOTO 880
C *** FEHLERMELDUNG
  910 WRITE(OUT,911)
  911 FORMAT(18H0PROGRAM-BREAKDOWN/1X,17(1H!)// 83H YOU HAVE TO INCREASE
     & THE DIMENSION OF THE ARRAY "ARRAY" TO THE ABOVE PRINTED VALUE
     &)
      RETURN
      END
C
      SUBROUTINE SECT(ISECT,IH)
C
      INTEGER IH(3),ITEMP
C
      IF(ISECT)25,25,5
    5 GO TO (10,30,50,60,70),ISECT
C             XZY SECTIONS
   10 ITEMP=IH(2)
   20 IH(2)=IH(3)
      IH(3)=ITEMP
   25 RETURN
C             YXZ SECTIONS
   30 ITEMP=IH(2)
   40 IH(2)=IH(1)
      IH(1)=ITEMP
      RETURN
C             YZX SECTIONS
   50 ITEMP=IH(1)
      IH(1)=IH(2)
      GO TO 20
C             ZYX SECTIONS
   60 ITEMP=IH(1)
      IH(1)=IH(3)
      IH(3)=ITEMP
      RETURN
C             ZXY SECTIONS
   70 ITEMP=IH(3)
      IH(3)=IH(2)
      GO TO 40
      END
C
      SUBROUTINE SECTR(ISECT,IH)
C
      REAL IH(3),ITEMP
C
      IF(ISECT)25,25,5
    5 GO TO (10,30,50,60,70),ISECT
C             XZY SECTIONS
   10 ITEMP=IH(2)
   20 IH(2)=IH(3)
      IH(3)=ITEMP
   25 RETURN
C             YXZ SECTIONS
   30 ITEMP=IH(2)
   40 IH(2)=IH(1)
      IH(1)=ITEMP
      RETURN
C             YZX SECTIONS
   50 ITEMP=IH(1)
      IH(1)=IH(2)
      GO TO 20
C             ZYX SECTIONS
   60 ITEMP=IH(1)
      IH(1)=IH(3)
      IH(3)=ITEMP
      RETURN
C             ZXY SECTIONS
   70 ITEMP=IH(3)
      IH(3)=IH(2)
      GO TO 40
      END
C
      SUBROUTINE ACHSE(ISECT,IX,IXI,IXF,IY,IYI,IYF,IZ,IZI,IZF)
C
C *** TRANSFORMIERT DIE GRIDPOINTACHSENANGABE, DIE STETS IN DER
C *** REIHENFOLGE X,Y,Z ERFOLGT, AUF DIE REIHENFOLGE DER GEWAEHLTEN
C *** SECTION.
C
      IF(ISECT)25,25,5
    5 GO TO (10,30,50,60,70),ISECT
C             XZY SECTIONS
   10 IW  = IY
      IWI = IYI
      IWF = IYF
   20 IY =IZ
      IYI=IZI
      IYF=IZF
      IZ =IW
      IZI=IWI
      IZF=IWF
   25 RETURN
C             YXZ SECTIONS
   30 IW = IY
      IWI=IYI
      IWF=IYF
   40 IY=IX
      IYI=IXI
      IYF=IXF
      IX=IW
      IXI=IWI
      IXF=IWF
      RETURN
C             YZX SECTIONS
   50 IW=IX
      IWI=IXI
      IWF=IXF
      IX=IY
      IXI=IYI
      IXF=IYF
      GO TO 20
C             ZYX SECTIONS
   60 IW=IX
      IWI=IXI
      IWF=IXF
      IX=IZ
      IXI=IZI
      IXF=IZF
      IZ=IW
      IZI=IWI
      IZF=IWF
      RETURN
C             ZXY SECTIONS

   70 IW=IZ
      IWI=IZI
      IWF=IZF
      IZ=IY
      IZI=IYI
      IZF=IYF
      GO TO 40
      END
C
      SUBROUTINE ARB(ISECT,CELL,ALF,BET,GAM,AG,BG,CG,JACHS)
C
C *** IN DIESER SUBROUT. WERDEN DIE ZELLENPARAMETER IN DIE RIEHEN-
C *** FOLGE GEBRACHT, DASS SIE DEM GEWAEHLTEN FOURIERSCHNITT ENT-
C *** SPRECHEN. DADURCH WIRD IM PROGRAMM ARBSEC STETS DIE RICHTIGE
C *** EBENENBERECHNUNG ERMOEGLICHT.
C
      DIMENSION CELL(6)
      IF(ISECT)1,1,30
   30 GOTO(2,3,4,5,6),ISECT
    1 CELL(1)=AG
      CELL(2)=BG
      CELL(3)=CG
      CELL(4)=ALF
      CELL(5)=BET
      CELL(6)=GAM
      JACHS=0
      RETURN
    2 CELL(1)=AG
      CELL(2)=CG
      CELL(3)=BG
      CELL(4)=ALF
      CELL(5)=GAM
      CELL(6)=BET
      JACHS=1
      RETURN
    3 CELL(1)=BG
      CELL(2)=AG
      CELL(3)=CG
      CELL(4)=BET
      CELL(5)=ALF
      CELL(6)=GAM
      JACHS=2
      RETURN
    4 CELL(1)=BG
      CELL(2)=CG
      CELL(3)=AG
      CELL(4)=GAM
      CELL(5)=BET
      CELL(6)=ALF
      JACHS=3
      RETURN
    5 CELL(1)=CG
      CELL(2)=BG
      CELL(3)=AG
      CELL(4)=GAM
      CELL(5)=ALF
      CELL(6)=BET
      JACHS=4
      RETURN
    6 CELL(1)=CG
      CELL(2)=AG
      CELL(3)=BG
      CELL(4)=GAM
      CELL(5)=ALF
      CELL(6)=BET
      JACHS=5
      RETURN
      END
C
      SUBROUTINE PATSON(IFILE)
C
C---- GENERATION OF A FOURIERFILE
C
C
      DIMENSION      A(6),ANG(3),ITNS(8),TRS(8),JRMAT(10),CELLP(3,4),
     & IRMAT(2,3),JTNS(3), TRANS(3,24),RMAT(3,3,24), KRMAT(10),JA(2),
     & LABEL(3),TITLE(18),FBUF(504),IFBUF(504),FRMT(18),IH(3),IZELLE(
     & 7)
C
      EQUIVALENCE (FBUF,IFBUF)
C***      DATA FBUF/504*0.0/,IFBUF/504*0/
      DATA TITLE/4HGENE,4HRATI,4HON O,4HF A ,4HFOUR,4HIER-,4HFILE,
     & 4H FOR,4H A P,4HATTE,4HRSON,4HSYNT,4HHESI,1HS,1H ,1H ,1H ,1H /
      DATA FBUF/504*0.0/,IFBUF/504*0/
      DATA IH/3*0/
      DATA IN,IOUT,IFOUR,IENDE,IHKL /5,6,13,3HEND,3HHKL/
      DATA ITNS/3H   ,3H1/2,3H1/3,3H2/3,3H1/4,3H3/4,3H1/6,3H5/6/
      DATA TRS/0.0,0.5,0.33333333,0.66666666,0.25,0.75,
     &  0.166666667,0.83333333/
      DATA KRMAT/0,1,1,-1,2,2,-2,3,3,-3/
      DATA JRMAT/3H   ,3H  X,3H +X,3H -X,3H  Y,3H +Y,3H -Y,3H  Z,3H +Z,
     1 3H -Z/
      DATA JA/8HCENTRIC ,8HACENTRIC/
      DATA IZELLE/1HP,1HA,1HB,1HC,1HI,1HF,1HR/
   12 FORMAT(3(3A3,1X),I4)
   13 FORMAT(5X,3(3A3,1X),I4)
   64 FORMAT(31H0ERROR IN SYMMETRY OPERATOR NO.,I3,1H.//16H JOB TERMINAT
     1ED.)
   68 FORMAT(25H0TOO MANY SYMMETRY CARDS.//16H JOB TERMINATED.)
      PI=ACOS(-1.)
C
C---- PRINT TITLE.
C
      WRITE(IOUT,99)
   99 FORMAT(30H1*GENERATION OF A FOURIERFILE*/1X,29(1H-)//)
C
C---- READ MAINFILE-TITLE AND LATTICE CONSTANTS.
C
      READ(IN,1)LABEL,A
    1 FORMAT(3A4/6F8.0)
C
C---- CALCULATE VOLUME OF UNITCELL.
C
      DO 2 I=1,3
    2 ANG(I)=COS( A(I+3)*PI/180. )
      VOL=A(1)*A(2)*A(3)*SQRT(1.-ANG(1)**2-ANG(2)**2-ANG(3)**2
     & +2.*ANG(1)*ANG(2)*ANG(3))
C
C---- PRINT VOLUME AND CELL PARAMETERS.
C
      WRITE(IOUT,3)A,VOL
    3 FORMAT(18H LATTICE-CONSTANTS/1X,17(1H-)//1X,4HAXES,15X,3(F10.4,3X)
     &//1X,6HANGLES,13X,3(F10.4,3X)/19H VOLUME OF UNITCELL,F10.4)
C
C---- READ AND PRINT CENTRICITY AND CELLTYPE.
C
      READ(IN,4)ICENT,ICELL
    4 FORMAT(2I3)
      WRITE(IOUT,5)JA(ICENT+1),IZELLE(ICELL+1)
    5 FORMAT(22H0CELL CHARACTERISATION/1X,21(1H-)//1X,A8,9H CELL OF ,A1
     &,6H TYPE.)
C
C---- WHAT IS ABOUT NEGATIVE INTENSITIES?
C
      WRITE(IOUT,6)
    6 FORMAT(17H0IMPORTANT NOTICE/1X,16(1H-)//1X,20HNEGATIVE INTENSITIES
     & ,17H ARE SET TO ZERO. //15H0SYMMETRY CARDS/1X,14(1H-)//)
C
C---- READ SYMMETRY CARDS AND CALCULATE SYMMETRY MATRICES.
C
                             DO 220 I=1,3
  220 CELLP(I,1)=0.0
      JCELL=1
      IF(ICELL)230,320,230
  230 IF(ICELL-5)232,270,300
  232                        DO 240 I=1,3
  240 CELLP(I,2)=0.5
      JCELL=2
      IF(ICELL-4)250,320,250
  250 CELLP(ICELL,2)=0.0
      GO TO 320
  270                        DO 290 I=2,4
                             DO 280 J=1,3
  280 CELLP(J,I)=0.5
  290 CELLP(I-1,I)=0.0
      JCELL=4
      GO TO 320
  300 JCELL=3
                             DO 310 I=2,3
      CELLP(1,I)=FLOAT(I-1)/3.0
      CELLP(2,I)=FLOAT(4-I)/3.0
  310 CELLP(3,I)=CELLP(2,I)
  320 NSYM=0
  330 NSYM=NSYM+1
      READ(IN,12)(JTNS(I),(IRMAT(K,I),K=1,2),I=1,3),IEF
C
C---- PRINT SYMMETRY CARDS.
C
      WRITE(IOUT,13)(JTNS(I),(IRMAT(K,I),K=1,2),I=1,3),IEF
                             DO 390 I=1,3
                             DO 340 J=1,8
      IF(JTNS(I)-ITNS(J)) 340,350,340
  340 CONTINUE
  342 WRITE(IOUT,64)NSYM
      STOP
  350 TRANS(I,NSYM)=TRS(J)
                             DO 390 J=1,3
      RMAT(J,I,NSYM)=0.0
                             DO 390 K=1,2
      IJ=IRMAT(K,J)
                             DO 360 L=1,10
      IF(JRMAT(L)-IJ) 360,370,360
  360 CONTINUE
      GOTO 342
  370 IF(I-IABS(KRMAT(L))) 390,380,390
  380 RMAT(J,I,NSYM)=ISIGN(1,KRMAT(L))
  390 CONTINUE
      IF(IEF) 420,400,420
  400 IF(NSYM-24) 330,410,410
  410 WRITE(IOUT,68)
      STOP
  420 CONTINUE
C
C---- SPECIAL UNIT FOR FOURIERFILE REQUIRED?
C
      IF(IFILE.NE.0) IFOUR=IFILE
C
C---- GENERATE NOW THE FOURIERFILE.
C
      REWIND IFOUR
      WRITE(IFOUR)LABEL,TITLE,A(4),A(5),A(6),A(1),A(2),A(3)
      WRITE(IFOUR)NSYM,VOL,(((RMAT(I,J,K),I=1,3),J=1,3),K=1,NSYM),
     &((TRANS(J,I),J=1,3),I=1,NSYM),(TRS(1),I=1,6)
      NFBR=0
C
C---- READ FORMATCARD FOR HKL CARDS.
C
      READ(IN,7)FRMT
    7 FORMAT(18A4)
C
C---- READ STRUCTURE FACTORS AND WRITE THESE TO THE FOURIERFILE.
C
  980 READ(IN,FRMT,END=5000)IEF,IH,MREJ,FOBS,SIGMA
      IF(IEF.EQ.IENDE.OR.IEF.NE.IHKL) GOTO 5000
      IF(FOBS.LT.0.) FOBS=0.
      FOBS=SQRT(FOBS)
      IF(FOBS.LT..01) FOBS=.01
      SIGMA=0.5*SIGMA/FOBS
      IFBUF(NFBR+1)=IH(1)
      IFBUF(NFBR+2)=IH(2)
      IFBUF(NFBR+3)=IH(3)
      FBUF(NFBR+4) =FOBS
      FBUF(NFBR+5)=0.0
      FBUF(NFBR+6)=0.0
      FBUF(NFBR+7)=0.0
      IFBUF(NFBR+8)=MREJ-1
      FBUF(NFBR+9)=SIGMA
      FBUF(NFBR+10)=1.0
      NFBR=NFBR+10
      IF(NFBR-500) 980,972,972
  972 WRITE(IFOUR)FBUF
      NFBR=0
      GOTO 980
 5000 IFBUF(NFBR+1)=99
      WRITE(IFOUR)FBUF
      END FILE IFOUR
C
C---- REPORT SUCCESSFUL  GENEERATION.
C
      WRITE(IOUT,9)
   9  FORMAT(//30H0GENERATION HAD BEEN SUCCEDED.)
      RETURN
      END
C
      SUBROUTINE REFMUL(RMAT,NSYM,IWAHL,IN,FMULT)
C
C---- PROGRAM CALCULATES REFLECTION MULTIPLICITIES
C     WRITTEN BY W.F.KUHS AT MPI FKF MARCH 80
C
C      RMAT     ROTATIONAL SYMMETRY OPERATORS
C      NSYM     NUMBER OF SYMMETRY OPERATORS
C      IWAHL    SWITCH FOR CALCULATION OR READING OF FMULT
C      IN       INPUT UNIT
C      FMULT    MULTIPLICITIES OF REFLECTION TYPES
C
      COMMON /MATRIX/ MAT(3,3,24),MH(3)
C
      DIMENSION FMULT(12),RMAT(3,3,24),IW(2)
C
      DATA IW/4HCARD,4HCALC/
C
      IF(IWAHL.EQ.IW(2)) GOTO 40
      READ(IN,20) FMULT
   20 FORMAT(12F6.0)
      RETURN
C
C---- CHANGE TYPE OF RMAT TO INTEGER
C
   40 NSY = NSYM
      DO 50 I=1,NSY
      DO 50 J=1,3
      DO 50 K=1,3
      MAT(K,J,I) = IFIX(RMAT(K,J,I))
   50 CONTINUE
C
C---- REFLECTION TYPE H00
C
      MH(1) = 1
      MH(2) = 0
      MH(3) = 0
      FMULT(1) = FLOAT(MAM(NSY))
C
C---- REFLECTION TYPE 00L
C
      MH(1) = 0
      MH(3) = 1
      FMULT(2) = FLOAT(MAM(NSY))
C
C---- REFLECTION TYPE HK0
C
      MH(1) = 1
      MH(2) = 4
      MH(3) = 0
      FMULT(3) = FLOAT(MAM(NSY))
C
C---- REFLECTION TYPE H0L
C
      MH(2) = 0
      MH(3) = 4
      FMULT(4) = FLOAT(MAM(NSY))
C
C---- REFLECTION TYPE 0KL
C
      MH(1) = 0
      MH(2) = 1
      FMULT(5) = FLOAT(MAM(NSY))
C
C---- REFLECTION TYPE HH0
C
      MH(1) = 1
      MH(3) = 0
      FMULT(6) = FLOAT(MAM(NSY))
C
C---- REFLECTION TYPE H0H
C
      MH(2) = 0
      MH(3) = 1
      FMULT(7) = FLOAT(MAM(NSY))
C
C---- REFLECTION TYPE 0KK
C
      MH(1) = 0
      MH(2) = 1
      FMULT(8) = FLOAT(MAM(NSY))
C
C---- REFLECTION TYPE HHH
C
      MH(1) = 1
      FMULT(9) = FLOAT(MAM(NSY))
C
C---- REFLECTION TYPE HHL
C
      MH(3) = 4
      FMULT(10) = FLOAT(MAM(NSY))
C
C---- REFLECTION TYPE HKK
C
      MH(2) = 4
      FMULT(11) = FLOAT(MAM(NSY))
C
C---- REFLECTION TYPE HKL
C
      MH(3) = 7
      FMULT(12) = FLOAT(MAM(NSY))
      RETURN
      END
      FUNCTION MAM(NSY)

C---- CALCULATES AND COMPARES SYMMETRICALLY EQUIVALENT REFLECTIONS

      COMMON /MATRIX/ MAT(3,3,24),MH(3)
      DIMENSION II(3)
      IEQ = 0
      DO 100 I=1,NSY
      DO 110 J=1,3
      II(J) = 0
      DO 110 L=1,3
      II(J) = II(J) + MH(L) * MAT(J,L,I)
  110 CONTINUE
      IF(II(1).EQ.MH(1).AND.II(2).EQ.MH(2).AND.II(3).EQ.MH(3)) IEQ=IEQ+1
      IF(II(1).EQ.-MH(1).AND.II(2).EQ.-MH(2).AND.II(3).EQ.-MH(3))
     & IEQ=IEQ+1
  100 CONTINUE
      MAM = NSY/IEQ
      RETURN
      END
