C      PROGRAM eingabe(PROFEIN,PREPEIN,INPUT,OUTPUT,TAPE5=INPUT,
C     *TAPE6=OUTPUT,TAPE2=PROFEIN,TAPE3,TAPE7=PREPEIN)
C     H. BOYSEN    NOV 1989
      INTEGER IO(35),NPREFOR(5),NRTYP(5),NSYMOP(5),MVRM(5)
      INTEGER NNUC(5),NMAG(5),NATOM(5),NANI(50),KK(5)
      REAL U(5),V(5),W(5),A(5),B(5),C(5),AL(5),BE(5),GA(5)
      REAL RIO(50),STR(50),STRI(50)
      CHARACTER*4  TEXT*132,CHAR*1,ATOM(50),PHASEN(5)*16,SPGP(5)*16
      LOGICAL COPY,ATOF,ISOT,CCONST,ANH3,ANH4
C
      OPEN(2,FILE="profein")
      OPEN(7,FILE="prepein")
C
      IANT=1
20    COPY=.FALSE.
C-------------- LINE 1 -----------------  TITLE -----------------------
        PRINT *,' GIB TITEL'
        READ(5,'(A)')TEXT
      WRITE(2,'(A)')TEXT
      WRITE(7,'(A)')TEXT
C-----------------------------LINE 2 ----------OVERALL REFINEMENT-------
        PRINT 30
30      FORMAT(' NCYCLE,NPAT,NPAR,N2THMIN,NCBACK')
      READ(5,*,END=40)NCYCLE,NPAT,NPAR,N2THMIN,NCBACK
40    CONTINUE
45    WRITE(2,*)NCYCLE,NPAT,NPAR,N2THMIN,NCBACK
      WRITE(7,*) NPAT
C----------------------------- LINE 3 -----------TEXT FOR EACH PATTERN---
      LUN=5
      DO 50 I=1,NPAT
      PRINT *,' GIB TEXT PATTERN ',I
      READ(LUN,'(A)')PHASEN(I)
50    WRITE(2,'(A)')PHASEN(I)
C     READ(LUN,'(A16)')TEXT(1+(I-1)*16:16+(I-1)*16)
C50    WRITE(2,'(A16)') TEXT(1+(I-1)*16:16+(I-1)*16)
C----------------------------LINE 4 ------------- REFINEMENT TYPE ---------
      DO 60 I=1,NPAT
      PRINT *,' NRTYP, NPREFOR ','PAT. ',I
      READ(5,*,END=70)NRTYP(I),NPREFOR(I)
70    CONTINUE
60    WRITE(2,*)NRTYP(I),NPREFOR(I)
C-----------------------------------LINE 5 ---- OUTPUT OPTIONS -------------
C     PRINT *,' OUTPUT-OPTIONS ',(IO(I),I=1,7)
C     READ(5,*,END=80)(IO(I),I=1,7)
80    CONTINUE
      IO(1)=1
      IO(2)=0
      IO(3)=1
      IO(4)=0
      IO(5)=0
      IO(6)=80
      IO(7)=0
85    NPLO=IO(2)
      WRITE(2,*)(IO(I),I=1,7)
C-------------------------------LINE 6 ------ CONSTRAINTS INDICATORS ------
      PRINT *,' CONSTRAINTS ANZAHL STRICT,CHEMICAL'
      READ(5,*,END=90)(IO(I),I=1,2)
90    CONTINUE
      WRITE(2,*)(IO(I),I=1,2)
      ICONST=IO(1)
C------------------------------ LINE 7 ------ STRUCTURE INDICATORS ---------
      DO 120 I=1,NPAT
      PRINT *,'NCENTRO,NSYM,NATOM,NNUC,NMAG'
      READ(5,*,END=100)(IO(K),K=1,5)
100   CONTINUE
      NSYMOP(I)=IO(2)
      MVRM(I)=0
      NNUC(I)=IO(4)
      NMAG(I)=IO(5)
      NATOM(I)=IO(3)
120   WRITE(2,*)(IO(K),K=1,5)
C------------------------------- LINE 8 --- REF. REGULATORS AND LAMBDA --
      JJ=7
      IF(NRTYP(1).LE.3) JJ=6
      PRINT *,' EPS,LAMBDA, LAMBDA(ALPHA2) ,4*RELAX'
      READ(5,*,END=130)(RIO(I),I=1,JJ)
130   CONTINUE
      FLABDA=RIO(2)
      WRITE(2,*)(RIO(I),I=1,JJ)
C---------------------------- LINE 9 --- PREFERRED ORIENTATION AXIS --
      DO 145 K=1,NPAT
      IF(NPREFOR(K).EQ.0)GOTO 145
      PRINT *,' MILLER IND. PREFERRED ORIENTATION  PHASE ',K
      READ(5,*,END=140)(RIO(I),I=1,3)
140   CONTINUE
      WRITE(2,*)(RIO(I),I=1,3)
145   CONTINUE
C-------------- LINE 10 --- UNIQUE MAGNETIC AXES -----------------
      DO 160 K=1,NPAT
      IF(NRTYP(K).EQ.2) THEN
      PRINT *,' MILLER IND. UNIQUE MAGNETIC AXES  PHASE ',K
      READ(5,*,END=150)(RIO(I),I=1,3)
150   CONTINUE
      WRITE(2,*)(RIO(I),I=1,3)
      ENDIF
160   CONTINUE
C--------------- LINE 11 --- SYMMETRY OPERATORS -----------------------
      DO 180 K=1,NPAT
        PRINT *,' PHASE ',K
        PRINT *,' SYM.-KARTEN VON FILE = 0, EINGABE = 1, SPGP=2'
        READ(5,*,END=175)IIA
        GOTO 176
175     CONTINUE
        IIA=0
176     IF(IIA.EQ.0)THEN
          CALL SYMTRA
          GOTO 180
        ENDIF
        IF(IIA.EQ.2) THEN
        CALL SYMAC
          GOTO 180
        ENDIF
      DO 170 J=1,NSYMOP(K)
      PRINT *,' GIB SYMMETRIEOPERATOREN NR. ',J,' PHASE ',K
      READ(5,*)(RIO(I),I=1,12)
170   WRITE(2,*)(RIO(I),I=1,12)
180   CONTINUE
C-------------- LINE 11.A -- MAGNETIC VECTOR ROTATION MATRICES -------
185   DO 190 I=1,NPAT
      IF(MVRM(I).NE.0) THEN
      PRINT *,' FEHLER: MAG. VEKTOR ROTATIONS-MATRIZEN SIND NICH'
      STOP
      ENDIF
190   CONTINUE
C------------- LINE 12 --- SCATTERING LENGTH(S) ----------------------
      NU=0
      DO 200 I=1,NPAT
200   NU=NU+NNUC(I)
      PRINT *,' GIB ',NU,' STREULAENGEN'
      READ(5,*)(STR(I),I=1,NU)
210   WRITE(2,*)(STR(I),I=1,NU)
C------------------ LINE 12.A --- INCOHERENT CROSS SECTIONS ------------
      IF(NCBACK.EQ.0)GOTO 230
      PRINT *,' GIB ',NU,' INC. STREUQUERSCHNITTE'
      READ(5,*)(STRI(I),I=1,NU)
220   WRITE(2,*)(STRI(I),I=1,NU)
C----------------- OP. LINE 13 -- SCATTERING CURVES --------------------
230   MA=0
      DO 240 I=1,NPAT
240   MA=MA+NMAG(I)
      IF(MA.NE.0) THEN
        PRINT *,' FEHLER: STREUFUNKTIONEN SIND NICHT'
        STOP
      ENDIF
C---------- OP. LINE 13.A --- SPIN QUANTUM NUMBERS ---------------
      IF(NCBACK.EQ.0.AND.MA.EQ.0)GOTO 255
      PRINT *,' GIB ',MA,' SPINQUANTENZAHLEN'
      READ(5,*)(RIO(I),I=1,MA)
250   WRITE(2,*)(RIO(I),I=1,MA)
C-------------- LINE 14 -------- ATOMIC PARAMETERS ---------------
255   NR=0
      DO 260 I=1,NPAT
260   NR=NR+NATOM(I)
      DO 300 I=1,NR
265   FORMAT(A4,1X,2(I2,1X),5(F10.6,1X),I2)
      IF(COPY)GOTO 270
      PRINT *,' GIB ATOM-LABEL ',I
      READ(5,'(A4)')ATOM(I)
      PRINT *,' GIB NR.PAT,NR.STREU,X,Y,Z,B,N,ANISOB'
      READ(5,*)IO(1),IO(2),(RIO(K),K=1,5),IO(3)
      IF(IO(3).EQ.1.OR.IO(3).GE.3)READ(5,*)(RIO(K),K=6,11)
      IF(IO(3).GE.3)READ(5,*)(RIO(K),K=12,21)
      IF(IO(3).GE.4)READ(5,*)(RIO(K),K=22,36)
270   WRITE(2,265)ATOM(I),IO(1),IO(2),(RIO(K),K=1,5),IO(3)
      NANI(I)=IO(3)
      IF(IO(3).EQ.1.OR.IO(3).GE.3)WRITE(2,*)(RIO(K),K=6,11)
      IF(IO(3).GE.3)WRITE(2,12)(RIO(K),K=12,21)
      IF(IO(3).GE.4)WRITE(2,12)(RIO(K),K=22,31)
      IF(IO(3).GE.4)WRITE(2,12)(RIO(K),K=32,36)
   12 FORMAT(10(E10.4,1X))
  300 CONTINUE
C------------- LINE 15 --- SCALE & OVERALL TEPERATURE FACTORS ----
      DO 320 I=1,NPAT
      PRINT *,' GIB SKALEN- & OVERALL TEMP.- FAKTOR FUER ',PHASEN(I)
      READ(5,*)(RIO(K),K=1,2)
320   WRITE(2,*)(RIO(K),K=1,2)
C------------- LINE 16 --- ZEROPOINT ------------------------------
      PRINT *,' GIB ZEROPOINT(S)'
      READ(5,*)(RIO(K),K=1,NPAT)
330   WRITE(2,*)(RIO(K),K=1,NPAT)
      ZERO=RIO(1)
C--------------------LINE 17 --- U,V,W -----------------------------
      DO 350 I=1,NPAT
      PRINT *,' GIB U,V,W  FUER PHASE ',I,' ',PHASEN(I)
      READ(5,*)(RIO(K),K=1,3)
351   WRITE(2,*)(RIO(K),K=1,3)
      U(I)=RIO(1)
      V(I)=RIO(2)
      W(I)=RIO(3)
  350 CONTINUE
C-------------------LINE 18 --- CELL PARAMETERS ---------------------
      DO 360 I=1,NPAT
      PRINT *,'GIB CELL PARAMETER  PHASE ',I,' ',PHASEN(I)
      READ(5,*)(RIO(K),K=1,6)
361   WRITE(2,*)(RIO(K),K=1,6)
      A(I)=RIO(1)
      B(I)=RIO(2)
      C(I)=RIO(3)
      AL(I)=RIO(4)
      BE(I)=RIO(5)
      GA(I)=RIO(6)
  360 CONTINUE
C------------ OP. LINE 19 --- PREFERRED ORIENTATIN & ASYMMETRY PARAMETER---
      DO 370 I=1,NPAT
      KK(I)=0
      IF(N2THMIN.NE.0.OR.NPREFOR(I).NE.0)THEN
        IF(N2THMIN.NE.0.OR.NPREFOR(I).NE.0)KK(I)=1
        IF(N2THMIN.NE.0.AND.NPREFOR(I).NE.0)KK(I)=2
        IF(KK(I).EQ.1) THEN
          PRINT *,' GIB ASYM. BZW. PREFERRED ORI. PAR.',' ',PHASEN(I)
          READ(5,*)RIO(1)
        ENDIF
        IF(KK(I).EQ.2) THEN
          PRINT *,' GIB ASYM. UND PREFERRED ORI.PAR.',' ',PHASEN(I)
          READ(5,*)RIO(1),RIO(2)
        ENDIF
365   IF(KK(I).EQ.1)WRITE(2,366)RIO(1)
      IF(KK(I).EQ.2)WRITE(2,366)RIO(1),RIO(2)
      ENDIF
366   FORMAT(1X,F12.6,1X,F12.6)
370   CONTINUE
C----------------------------------------------------------------------
C                                   CODEWORDS              ------------
C----------------------------------------------------------------------
      PRINT *,' ATOMPARAMETER FREI (0,1),ANISOTROP (0,1),ANHARM(0,3,4)?'
      READ(5,*,END=380)IAF,NPA,NANH
      GOTO 390
380   CONTINUE
      IAF=0
      NPA=0
      NANH=0
390   ATOF=(IAF.EQ.1)
      ISOT=(NPA.EQ.0)
      ANH3=(NANH.GE.3)
      ANH4=(NANH.EQ.4)
C     COPY=.FALSE.
      DO 400 I=1,NR
      IF(COPY)THEN
        READ(3,*)(RIO(K),K=1,5)
        IF(NANI(I).NE.0)READ(3,*)(RIO(K),K=6,11)
        IF(NANI(I).GE.3)READ(3,*)(RIO(K),K=12,21)
        IF(NANI(I).GE.4)READ(3,*)(RIO(K),K=22,36)
      ENDIF
      IF(.NOT.ATOF)THEN
        DO 392 K=1,5
392     RIO(K)=0.
      ENDIF
      IF(ISOT)THEN
        DO 394 K=6,11
394     RIO(K)=0.
      ENDIF
      IF(.NOT.ANH3) THEN
      DO 873 K=12,21
  873 RIO(K)=0.
      ENDIF
      IF(.NOT.ANH4)THEN
      DO 874 K=22,36
  874 RIO(K)=0.
      ENDIF
      IF(.NOT.ATOF)GOTO396
      PRINT *,' GIB CODEWORDS ATOMPARAMETER ',ATOM(I),' ATOM ',I
      READ(5,*,END=395)(RIO(K),K=1,5)
      GOTO 396
395   CONTINUE
      DO 1395 K=1,5
1395  RIO(K)=0.
396   IF(ISOT)GOTO398
      IF(NANI(I).NE.0)THEN
        PRINT *,' GIB ANISOTROPE TEMP. CODEWORDS',ATOM(I)
        READ(5,*,END=397)(RIO(K),K=6,11)
        GOTO 398
397     CONTINUE
        DO 1397 K=6,11
1397    RIO(K)=0.
      ENDIF
398   WRITE(2,*)(RIO(K),K=1,5)
      IF(NANI(I).NE.0)WRITE(2,*)(RIO(K),K=6,11)
      IF(.NOT.ANH3) GOTO 763
      IF(NANI(I).GE.3) THEN
      PRINT*,'GIB ANH-3 CODES',ATOM(I)
      READ(5,*,END=761) (RIO(K),K=12,21)
      GOTO 763
  761 CONTINUE
      DO 771 K=12,21
  771 RIO(K)=0.
      ENDIF
  763 IF(NANI(I).GE.3) WRITE(2,*) (RIO(K),K=12,21)
  764 IF(.NOT.ANH4) GOTO 773
      IF(NANI(I).EQ.4) THEN
      PRINT*,' GIB ANH-4 CODES',ATOM(I)
      READ(5,*,END=772) (RIO(K),K=22,36)
      GOTO 773
  772 CONTINUE
      DO 775 K=22,36
  775 RIO(K)=0.
      ENDIF
  773 IF(NANI(I).EQ.4) WRITE(2,*) (RIO(K),K=22,31)
      IF(NANI(I).EQ.4) WRITE(2,*) (RIO(K),K=32,36)
  400 CONTINUE
C------ LINE 21 --- CODE SCALE & OVERALL TEMP. -----------------
      DO 410 I=1,NPAT
      IF(COPY)READ(3,*)RIO(1),RIO(2)
      PRINT *,' CODEWORDS SCALE & OVERALL TEMP. PHASE ',I,' ',PHASEN(I)
      READ(5,*,END=405)RIO(1),RIO(2)
      GOTO 410
405   CONTINUE
      RIO(1)=0.
      RIO(2)=0.
410   WRITE(2,*)RIO(1),RIO(2)
C--------LINE 22 --- CODE ZEROPOINT -------------------------------
      IF(COPY)READ(3,*)(RIO(K),K=1,NPAT)
      PRINT *,'CODEWORD(S) ZEROPOINT(S)'
      READ(5,*,END=412)(RIO(K),K=1,NPAT)
      GOTO 414
412   CONTINUE
      DO 413 I=1,NPAT
413   RIO(I)=0.
414   WRITE(2,*)(RIO(K),K=1,NPAT)
C-------- LINE 23 ---- CODE U,V,W ----------------------------------
      DO 420 I=1,NPAT
      IF(COPY)READ(3,*)(RIO(K),K=1,3)
      PRINT *,' CODEWORDS U,V,W   PHASE ',I,' ',PHASEN(I)
      READ(5,*,END=416)(RIO(K),K=1,3)
      GOTO 420
416   CONTINUE
      RIO(1)=0.
      RIO(2)=0.
      RIO(3)=0.
420   WRITE(2,*)(RIO(K),K=1,3)
C-------- LINE 24 ---  CODE CELL PARAMETERS ------------------------
      DO 430 I=1,NPAT
      IF(COPY)READ(3,*)(RIO(K),K=1,6)
      PRINT *,' CODEWORDS CELL PARAMETERS PHASE ',I,' ',PHASEN(I)
      READ(5,*,END=425)(RIO(K),K=1,6)
      GOTO 430
425   CONTINUE
      DO 426 K=1,6
426   RIO(K)=0.
430   WRITE(2,*)(RIO(K),K=1,6)
C-------- LINE 25 ---  CODE PREF. ORI. & ASYMMETRY ------------------
      DO 450 I=1,NPAT
      IF(COPY.AND.KK(I).NE.0)READ(3,*)(RIO(K),K=1,KK(I))
      IF(KK(I).EQ.0)GOTO 450
      PRINT *,'CODEWORDS PREF. ORIENT. BZW. ASYMMETRIE PHASE ',I
      READ(5,*,END=445)(RIO(K),K=1,KK(I))
      GOTO 450
445   CONTINUE
      DO 446 K=1,KK(I)
446   RIO(K)=0.
450   WRITE(2,*)(RIO(K),K=1,KK(I))
C----------------------------------------------------------------------
C        CONSTRAINTS    STRICT CONSTRAINTS ONLY!!
C
      IF(ICONST.EQ.0)GOTO460
      PRINT*,' CONSTRAINTS VERAENDERN O. INITIALISIEREN? CR=<NEIN>'
      READ(5,451,END=4501)TEXT(1:1)
      GOTO 4502
4501  CONTINUE
      TEXT(1:1)='N'
4502  CCONST=.FALSE.
      IF(TEXT(1:1).NE.'N')CCONST=.TRUE.
451   FORMAT(A)
      DO 459 I=1,ICONST
      IL=0
452   IL=IL+1
      PRINT*,' CONSTR. EQU.(',I,') LINE ',IL
453   READ(5,451,END=454)TEXT
454   CONTINUE
      WRITE(2,451)TEXT
      READ(TEXT,'(F4.0)')RIO(1)
      IF(RIO(1).EQ.-100.)THEN
        IL=IL+1
        IF(.NOT.CCONST)GOTO455
        PRINT*,' CONSTR.  EQU.(',I,') VALUE = ',RIO(2)
        READ(5,451,END=455)RIO(2)
455     CONTINUE
        WRITE(2,*)RIO(2)
        GOTO 459
      ENDIF
      GOTO 452
459   CONTINUE
460   IF(NPLO.NE.0)THEN
      PRINT *,' LINEPRINTER -PLOT-PARAMETER'
      READ(5,*)(IO(K),K=1,3)
      WRITE(2,*)(IO(K),K=1,3)
      ENDIF
C
C   ..RESTOF PREPEIN
C
      DO 2010 I=1,NPAT
2010  WRITE(7,*) A(I),B(I),C(I),AL(I),BE(I),GA(I)
      PRINT*,' GIB STD.DEV. BACK, 2THETA-RANGE OF PEAK'
      READ(5,*) STBA,TTR
      WRITE(7,*) ZERO,STBA,FLABDA,TTR
      DO 2020 I=1,NPAT
2020  WRITE(7,*) U(I),V(I),W(I)
      PRINT*,' UNTERGRUND VOM FILE = 0, EINGABE =1'
      READ(5,*) IU
      IF(IU.EQ.0) THEN
      CALL UNTER
      ELSE
      READ(5,*) POS,BAK
      WRITE(7,*) POS,BAK
      ENDIF
C
      PRINT*,' GIB ANZAHL DER EXCLUDED REGIONS'
      READ(5,*) IEX
      IF (IEX.NE.0) THEN
      DO 2030 I=1,IEX
      READ(5,*) IPOS,IEXC
      WRITE(7,*) -IPOS,-IEXC
 2030 CONTINUE
       WRITE(7,*) '   -100   0'
      END IF
      PRINT*,' GIB GESAMTZAHL DER REFLEXE'
      READ(5,*) NGR
      WRITE(7,2040) NGR
 2040 FORMAT(5I8)
      IM=1
      DO 2050 I=1,NPAT
2050  WRITE(7,2040) IM,IM,IM
      DO 2080 I=1,NPAT
      PRINT*,' PHASE',I
      PRINT*,' HKL VOM FILE = 0, EINGABE = 1'
      READ(5,*) IHK
      IF(IHK.EQ.0) THEN
      CALL HKLES
      ELSE
      PRINT*,' ANZAHL?'
      READ(5,*) NA
      DO 2070 J=1,NA
      READ(5,*) I1,I2,I3,I4,I5
      WRITE(7,2040) I1,I2,I3,I4,I5
 2070 CONTINUE
      ENDIF
2080  CONTINUE
      PRINT*,' GIB FILNAME FUER DATEN'
      READ(5,'(A)') TEXT
      OPEN(11,FILE=TEXT)
      CALL COPYEI(TEXT,11,7,NR)
      STOP
      END
      SUBROUTINE SYMTRA
C----- LIEST DIE MIT SYMACH ERZEUGTEN SYMMETRIEKARTEN UND
C----- SCHREIBT SIE IN DIE RICHTIGE REIHENFOLGE UM.
C      H. SCHRADER
      CHARACTER LFN*7
C
      PRINT *,' GIB LFN MIT SYMMETRIEKARTEN'
      READ(5,'(A)')LFN
      OPEN(10,FILE=LFN)
      REWIND 10
10    READ(10,*,END=100)R1,R2,R3,T1,R4,R5,R6,T2,R7,R8,R9,T3
      WRITE(2,*)R1,R2,R3,T1,R4,R5,R6,T2,R7,R8,R9,T3
      GOTO 10
100   CLOSE(10)
      RETURN
      END
      SUBROUTINE UNTER
C----- LIEST UNTERGRUND
      CHARACTER LFN*7
C
      PRINT *,' GIB UNTERGRUND FILENAME    '
      READ(5,'(A)')LFN
      OPEN(10,FILE=LFN)
      REWIND 10
10    READ(10,*,END=100)U1,U2
      WRITE(7,*)U1,U2
      GOTO 10
100   CLOSE(10)
      RETURN
      END
      SUBROUTINE HKLES
C----- LIEST HKL-FILES
      CHARACTER LFN*7
C
      PRINT *,' GIB HKL FILENAME'
      READ(5,'(A)')LFN
      OPEN(10,FILE=LFN)
      REWIND 10
      CALL SKIPCR(TEXT,10,2)
10    READ(10,*,END=100)I1,I2,I3,I4,I5
      WRITE(7,3)I1,I2,I3,I4,I5
    3 FORMAT(5I8)
      GOTO 10
100   CLOSE(10)
      RETURN
      END
      SUBROUTINE COPYEI(REC,NI,NO,NR)
C
C     SR COPYEI KOPIERT AB POINTERPOS. ALLE RECORDS VON UNIT NI NACH UNI
C     MITGEZAEHLT WIRD AUF PARAMETER NR. OUTPUT.
C     H. SCHRADER, MAI 1986
C
      INTEGER NI,NO,NR
      CHARACTER REC*(*),BLANK*1
      BLANK=' '
      I=0
10    I=I+1
      REC=BLANK
      READ(NI,'(A)',END=90)REC
50    WRITE(NO,'(A)')REC
      GOTO 10
90    NR=I-1
      RETURN
      END
      SUBROUTINE SKIPCR(REC,NI,NR)
C
C     SR SKIPCR SKIP'T NR RECORDS AUF UNIT NI.
C     H. SCHRADER, MAI 1986
C
      INTEGER NI,NO,NR
      CHARACTER REC*(*)
      DO 50 I=1,NR
50    READ(NI,'(A)')REC
      RETURN
      END
      SUBROUTINE SYMAC
      COMMON /SYM/ RS(3,3,48),T(3,48),NGV,NG
      COMMON /UNITS/ IEIN,ILP,IAUS,ISF
      IEIN=5
      IAUS=6
      ILP=1
      ISF=2
      CALL SYMEL
      DO 10 I=2,NG
      WRITE(ISF,20) ((RS(K,J,I),K=1,3),J=1,3),(T(L,I),L=1,3)
   20 FORMAT(12F6.2)
   10 CONTINUE
C
      END
      SUBROUTINE SYMEL
      COMMON /BURC/ TS(24,3),ISS(24,3,3)
      COMMON /POSIT/ RN(3),RD(3),S1(3),S2(3),S3(3),IGR(45)
      COMMON /ND/ N3(20)
      COMMON /UNITS/ IEIN,ILP,IAUS,ISF
      COMMON /EQUO/ TT(3,24),ST(3,3,24),NG,ISY,ISYB
      COMMON /SYM/ RS(3,3,48),T(3,48),NGV,NGH
      WRITE(IAUS,10)
   10 FORMAT(1X,"GIB RAUMGRUPPE",/)
      READ(IEIN,100) (IGR(I),I=1,36)
  100 FORMAT(36A1)
      ISYST=0
      CALL BURZ(ISYST,ISY,ISB,NG)
      ISYB=BRA(ISB)
      NGH=NG
      NGV=(ISY+1)*NG
      DO 50 I=1,NG
      DO 50 J=1,3
      T(J,I)=TS(I,J)
      TT(J,I)=T(J,I)
      DO 50 K=1,3
      RS(K,J,I)=ISS(I,J,K)
      ST(K,J,I)=RS(K,J,I)
   50 CONTINUE
      IF (ISY.EQ.0) GOTO 60
      DO 55 I=1,NG
      DO 55 J=1,3
      T(J,NG+I)=-T(J,I)
      DO 55 K=1,3
      RS(K,J,NG+I)=-RS(K,J,I)
   55 CONTINUE
C
   60 CALL EQUI
      RETURN
      END
      SUBROUTINE BURZ (ISYSTM,ISYMCE,IBRAVL,NG)                         BURZ0000
C-----ROUTINE TO INTERPRET HERMANN MAUGUIN SYMBOL FOR SPACE GROUP       BURZ0001
C-----THIS ROUTINE HAS BEEN ADAPTED FROM A PROGRAM SUPPLIED BY          BURZ0002
C-----PROF. BURZLAFF, UNIVERSITY OF ERLANGEN, GERMANY                   BURZ0003
      COMMON /BURC/ TS,SS                                               BURZ0004
      COMMON /ND/N3(20)                                                 BURZ0005
      COMMON /POSIT/ RN,RD,S1,S2,S3,NT                                  BURZ0006
      COMMON /UNITS/ NRD,NPT,ILU                                        BURZ0007
      INTEGER E(3,3),ZEI(3,4),SS(24,3,3),SYS                            BURZ0008
      DIMENSION NT(45), IBRA(7), NMA(3), SH(3)                          BURZ0009
      DIMENSION RN(3), RD(3), S1(3), S2(3), S3(3)                       BURZ0010
      DIMENSION TS(24,3), TE(3)                                         BURZ0011
      DIMENSION ISYS(7)                                                 BURZ0012
      DATA ISYS(1)/7/,ISYS(2)/1/,ISYS(3)/2/,ISYS(4)/4/,ISYS(5)/6/,ISYS(6BURZ0013
     1)/5/,ISYS(7)/3/                                                   BURZ0014
      DATA IBRA(1)/1HP/,IBRA(2)/1HA/,IBRA(3)/1HB/,IBRA(4)/1HC/,IBRA(5)/1BURZ0015
     1HF/,IBRA(6)/1HI/,IBRA(7)/1HR/,NMA/3*0/,SH/3*0.25/                 BURZ0016
 1    NBL=-1                                                            BURZ0017
      NG=1                                                              BURZ0018
      NS=1                                                              BURZ0019
      DO 2 I=1,24                                                       BURZ0020
      DO 2 J=1,3                                                        BURZ0021
      TS(I,J)=0.0                                                       BURZ0022
      DO 2 K=1,3                                                        BURZ0023
      E(J,K)=0                                                          BURZ0024
      SS(I,J,K)=0                                                       BURZ0025
 2    CONTINUE                                                          BURZ0026
      SS(1,1,1)=1                                                       BURZ0027
      SS(1,2,2)=1                                                       BURZ0028
      SS(1,3,3)=1                                                       BURZ0029
      DO 3 I=1,3                                                        BURZ0030
      TE(I)=0.0                                                         BURZ0031
      DO 3 J=1,4                                                        BURZ0032
 3    ZEI(I,J)=0                                                        BURZ0033
      DO 8 I=1,36                                                       BURZ0034
      KXK=NT(I)                                                         BURZ0035
      IF (KXK.NE.N3(17)) GO TO 4                                        BURZ0036
      NLQ=0                                                             BURZ0037
      IC=0                                                              BURZ0038
      GO TO 8                                                           BURZ0039
 4    IF (NBL.GE.0) GO TO 7                                             BURZ0040
      DO 5 J=1,7                                                        BURZ0041
      NBR=J                                                             BURZ0042
      IF (KXK.EQ.IBRA(J)) GO TO 6                                       BURZ0043
 5    CONTINUE                                                          BURZ0044
 6    NBL=0                                                             BURZ0045
      IBRAVL=KXK                                                        BURZ0046
      GO TO 8                                                           BURZ0047
 7    IF (NLQ.EQ.0) NBL=NBL+1                                           BURZ0048
      IC=IC+1                                                           BURZ0049
      ZEI(NBL,IC)=KXK                                                   BURZ0050
      NLQ=1                                                             BURZ0051
      IF (KXK.EQ.N3(15)) NS=0                                           BURZ0052
 8    CONTINUE                                                          BURZ0053
      DO 9 I=1,4                                                        BURZ0054
      IF (ZEI(2,I).NE.N3(3)) GO TO 9                                    BURZ0055
      SYS=6                                                             BURZ0056
      GO TO 15                                                          BURZ0057
 9    CONTINUE                                                          BURZ0058
      DO 11 I=1,4                                                       BURZ0059
      IF (ZEI(1,I).NE.N3(3).AND.ZEI(1,I).NE.N3(6)) GO TO 10             BURZ0060
      SYS=5                                                             BURZ0061
      GO TO 15                                                          BURZ0062
 10   IF (ZEI(1,I).NE.N3(4)) GO TO 11                                   BURZ0063
      SYS=4                                                             BURZ0064
      GO TO 15                                                          BURZ0065
 11   CONTINUE                                                          BURZ0066
      IF (NBL.GT.1) GO TO 14                                            BURZ0067
      IF (ZEI(1,1).NE.N3(1).AND.ZEI(1,1).NE.N3(16)) GO TO 12            BURZ0068
      SYS=1                                                             BURZ0069
      GO TO 15                                                          BURZ0070
 12   SYS=2                                                             BURZ0071
      DO 13 I=1,4                                                       BURZ0072
 13   ZEI(2,I)=ZEI(1,I)                                                 BURZ0073
      ZEI(1,1)=N3(1)                                                    BURZ0074
      ZEI(3,1)=N3(1)                                                    BURZ0075
 14   SYS=3                                                             BURZ0076
      IF (ZEI(1,1).EQ.N3(1).OR.ZEI(2,1).EQ.N3(1)) SYS=2                 BURZ0077
 15   GO TO (16,17,22,46,58,68), SYS                                    BURZ0078
C-----TRICLINIC                                                         BURZ0079
 16   IF (ZEI(1,1).EQ.N3(16)) NS=0                                      BURZ0080
      GO TO 76                                                          BURZ0081
C-----MONOCLINIC                                                        BURZ0082
 17   NG=2                                                              BURZ0083
      DO 18 I=1,3                                                       BURZ0084
 18   IF (ZEI(I,1).NE.N3(1)) IND=I                                      BURZ0085
      ID=1                                                              BURZ0086
      IF (ZEI(IND,1).EQ.N3(2)) ID=-1                                    BURZ0087
      DO 19 I=1,3                                                       BURZ0088
 19   SS(2,I,I)=SS(1,I,I)*ID                                            BURZ0089
      SS(2,IND,IND)=-SS(2,IND,IND)                                      BURZ0090
      DO 21 I=1,3                                                       BURZ0091
      IF (ZEI(I,1).EQ.N3(2).AND.ZEI(I,2).EQ.N3(1)) TS(2,I)=0.5          BURZ0092
      DO 21 J=1,4                                                       BURZ0093
      IF (ZEI(I,J).EQ.N3(7)) TS(2,1)=0.5                                BURZ0094
      IF (ZEI(I,J).EQ.N3(8)) TS(2,2)=0.5                                BURZ0095
      IF (ZEI(I,J).EQ.N3(9)) TS(2,3)=0.5                                BURZ0096
      IF (ZEI(I,J).EQ.N3(12)) GO TO 20                                  BURZ0097
      GO TO 21                                                          BURZ0098
 20   K=I+1                                                             BURZ0099
      IF (K.GT.3) K=K-3                                                 BURZ0100
      TS(2,K)=0.5                                                       BURZ0101
      TS(2,6-K-I)=0.5                                                   BURZ0102
 21   CONTINUE                                                          BURZ0103
      GO TO 76                                                          BURZ0104
C-----ORTHORHOMBIC                                                      BURZ0105
 22   NG=4                                                              BURZ0106
      IC=0                                                              BURZ0107
      IND=1                                                             BURZ0108
      IF (ZEI(1,1).NE.N3(2).AND.ZEI(2,1).NE.N3(2).AND.ZEI(3,1).NE.N3(2))BURZ0109
     1IND=-1                                                            BURZ0110
      IF (IND.EQ.-1) NS=0                                               BURZ0111
      DO 24 I=1,3                                                       BURZ0112
      ID=1                                                              BURZ0113
      IF (ZEI(I,1).EQ.N3(2)) ID=-1                                      BURZ0114
      DO 23 J=1,3                                                       BURZ0115
 23   SS(1+I,J,J)=SS(1,J,J)*ID*IND                                      BURZ0116
 24   SS(1+I,I,I)=-SS(1+I,I,I)                                          BURZ0117
      DO 28 I=1,3                                                       BURZ0118
      IF (ZEI(I,1).EQ.N3(2).AND.ZEI(I,2).EQ.N3(1)) TS(1+I,I)=0.5        BURZ0119
      DO 28 J=1,4                                                       BURZ0120
      IF (ZEI(I,J).EQ.N3(7)) TS(1+I,1)=0.5                              BURZ0121
      IF (ZEI(I,J).EQ.N3(8)) TS(1+I,2)=0.5                              BURZ0122
      IF (ZEI(I,J).EQ.N3(9)) TS(1+I,3)=0.5                              BURZ0123
      IF (ZEI(I,J).EQ.N3(12).OR.ZEI(I,J).EQ.N3(10)) GO TO 25            BURZ0124
      GO TO 28                                                          BURZ0125
 25   K=I+1                                                             BURZ0126
      IF (K.GT.3) K=K-3                                                 BURZ0127
      IF (ZEI(I,J).EQ.N3(10)) GO TO 26                                  BURZ0128
      TS(1+I,K)=0.5                                                     BURZ0129
      TS(1+I,6-K-I)=0.5                                                 BURZ0130
      GO TO 28                                                          BURZ0131
 26   IC=1                                                              BURZ0132
      IF (NS.EQ.1) GO TO 27                                             BURZ0133
      TS(1+I,K)=0.25                                                    BURZ0134
      TS(1+I,6-K-I)=0.25                                                BURZ0135
      GO TO 28                                                          BURZ0136
 27   TS(1+I,1)=0.25                                                    BURZ0137
      TS(1+I,2)=0.25                                                    BURZ0138
      TS(1+I,3)=0.25                                                    BURZ0139
 28   CONTINUE                                                          BURZ0140
      IF (IC.EQ.1) GO TO 76                                             BURZ0141
      IF (NS.EQ.1) GO TO 36                                             BURZ0142
      DO 29 I=1,3                                                       BURZ0143
      K=1+I                                                             BURZ0144
      IF (K.GT.3) K=K-3                                                 BURZ0145
      TC=TS(1+K,I)+TS(1+6-I-K,I)                                        BURZ0146
      IF (TC.EQ.1.0) TC=0.0                                             BURZ0147
 29   TS(1+I,I)=TC                                                      BURZ0148
C-----SPECIAL TREATMENT OF C M M A, C M C A, I M M A                    BURZ0149
      IF (NBR.EQ.1.OR.NBR.EQ.5) GO TO 76                                BURZ0150
      MA=0                                                              BURZ0151
      DO 31 I=1,3                                                       BURZ0152
      DO 30 J=1,4                                                       BURZ0153
 30   IF (ZEI(I,J).EQ.N3(11)) NMA(I)=1                                  BURZ0154
 31   MA=MA+NMA(I)                                                      BURZ0155
      IF (NBR.EQ.6.AND.MA.EQ.2) GO TO 33                                BURZ0156
      IF (MA.EQ.0.OR.MA.EQ.3.OR.NBR.EQ.6) GO TO 76                      BURZ0157
      DO 32 I=1,3                                                       BURZ0158
      IF (NMA(NBR-1).EQ.1) GO TO 76                                     BURZ0159
 32   SH(NBR-1)=0.                                                      BURZ0160
C-----ORIGIN SHIFT                                                      BURZ0161
 33   DO 35 I=1,NG                                                      BURZ0162
      DO 35 J=1,3                                                       BURZ0163
      DO 34 K=1,3                                                       BURZ0164
      ID=1                                                              BURZ0165
      IF (J.NE.K) ID=0                                                  BURZ0166
 34   TS(I,J)=TS(I,J)+(ID-SS(I,J,K))*SH(K)                              BURZ0167
      IF (TS(I,J).GT.1.) TS(I,J)=TS(I,J)-1.                             BURZ0168
 35   IF (TS(I,J).LT.1.0) TS(I,J)=TS(I,J)+1.                            BURZ0169
      GO TO 76                                                          BURZ0170
 36   IC=0                                                              BURZ0171
      DO 37 I=1,3                                                       BURZ0172
 37   IF (SS(1+I,1,1)*SS(1+I,2,2)*SS(1+I,3,3).EQ.-1) IC=1               BURZ0173
      IF (IC.EQ.1) GO TO 41                                             BURZ0174
      TC=TS(2,1)+TS(3,2)+TS(4,3)                                        BURZ0175
      IF (TC.EQ.0.0) GO TO 76                                           BURZ0176
      DO 40 I=1,3                                                       BURZ0177
      K=I+1                                                             BURZ0178
      IF (K.GT.3) K=K-3                                                 BURZ0179
      IF (TC.GT.0.5) GO TO 38                                           BURZ0180
      IF (TS(1+I,I).EQ.0.0) GO TO 40                                    BURZ0181
      M=I-1                                                             BURZ0182
      IF (M.EQ.0) M=M+3                                                 BURZ0183
      TS(1+M,I)=0.5                                                     BURZ0184
      GO TO 40                                                          BURZ0185
 38   IF (TC.GT.1.0) GO TO 39                                           BURZ0186
      IF (TS(1+I,I).NE.0.0) GO TO 40                                    BURZ0187
      L=K+1                                                             BURZ0188
      IF (L.GT.3) L=L-3                                                 BURZ0189
      TS(1+K,L)=0.5                                                     BURZ0190
      TS(1+L,K)=0.5                                                     BURZ0191
      GO TO 40                                                          BURZ0192
 39   TS(1+I,K)=0.5                                                     BURZ0193
 40   CONTINUE                                                          BURZ0194
      GO TO 76                                                          BURZ0195
 41   DO 42 I=1,3                                                       BURZ0196
 42   IF (SS(1+I,1,1)*SS(1+I,2,2)*SS(1+I,3,3).EQ.1) ID=I                BURZ0197
      DO 45 I=1,3                                                       BURZ0198
      TC=TS(2,I)+TS(3,I)+TS(4,I)                                        BURZ0199
      IF (TC.EQ.0.0.OR.TC.EQ.1.0) GO TO 45                              BURZ0200
      IF (ZEI(1,1).EQ.N3(11).AND.ZEI(2,1).EQ.N3(12).OR.ZEI(2,1).EQ.     BURZ0201
     1N3(11).AND.ZEI(3,1).EQ.N3(12).OR.ZEI(3,1).EQ.N3(11).AND.ZEI(1,1)  BURZ0202
     2.EQ.N3(12)) GO TO 44                                              BURZ0203
      DO 43 J=1,3                                                       BURZ0204
      IF (ID.EQ.J) GO TO 43                                             BURZ0205
      IF (TS(1+J,I).EQ.0.5) GO TO 43                                    BURZ0206
      TS(1+J,I)=0.5                                                     BURZ0207
 43   CONTINUE                                                          BURZ0208
      GO TO 45                                                          BURZ0209
 44   K=I-1                                                             BURZ0210
      IF (K.EQ.0) K=K+3                                                 BURZ0211
      TS(1+K,I)=0.5                                                     BURZ0212
 45   CONTINUE                                                          BURZ0213
      GO TO 76                                                          BURZ0214
C-----TETRAGONAL                                                        BURZ0215
 46   NG=4                                                              BURZ0216
      IF (NBL.EQ.3) NG=8                                                BURZ0217
      SS(2,1,2)=-1                                                      BURZ0218
      SS(2,2,1)=1                                                       BURZ0219
      SS(2,3,3)=1                                                       BURZ0220
      M=ZEI(1,1)                                                        BURZ0221
      N=ZEI(1,2)                                                        BURZ0222
      DO 47 I=1,3                                                       BURZ0223
      DO 47 J=1,3                                                       BURZ0224
 47   IF (M.EQ.N3(16)) SS(2,I,J)=-SS(2,I,J)                             BURZ0225
      IF (M.EQ.N3(16)) GO TO 50                                         BURZ0226
      IF (N.EQ.N3(1)) TS(2,3)=0.25                                      BURZ0227
      IF (N.EQ.N3(2)) TS(2,3)=0.5                                       BURZ0228
      IF (N.EQ.N3(3)) TS(2,3)=0.75                                      BURZ0229
      IF (ZEI(1,3).EQ.N3(12).OR.(ZEI(1,4).EQ.N3(12).AND.NBL.EQ.3))      BURZ0230
     1TS(2,1)=0.5                                                       BURZ0231
      IF ((ZEI(1,4).EQ.N3(12).AND.NBL.EQ.1).OR.(N.EQ.N3(1).AND.NS.EQ.1. BURZ0232
     1AND.NBR.EQ.6)) TS(2,2)=0.5                                        BURZ0233
      IF (N.EQ.N3(1).AND.NS.EQ.0.AND.NBR.EQ.6) GO TO 48                 BURZ0234
      IF (ZEI(2,2).EQ.N3(1).OR.(ZEI(1,4).NE.N3(12).AND.ZEI(2,1).EQ.     BURZ0235
     1N3(12).AND.ZEI(3,1).EQ.N3(11))) GO TO 49                          BURZ0236
      GO TO 50                                                          BURZ0237
 48   TS(2,1)=0.25                                                      BURZ0238
      TS(2,2)=0.75                                                      BURZ0239
      IF (NBL.EQ.1) TS(2,1)=0.75                                        BURZ0240
      IF (NBL.EQ.1) TS(2,2)=0.25                                        BURZ0241
      GO TO 50                                                          BURZ0242
 49   TS(2,1)=0.5                                                       BURZ0243
      TS(2,2)=0.5                                                       BURZ0244
 50   SS(3,1,1)=-1                                                      BURZ0245
      SS(3,2,2)=-1                                                      BURZ0246
      SS(3,3,3)=1                                                       BURZ0247
      TS(3,1)=SS(2,1,2)*TS(2,2)+TS(2,1)                                 BURZ0248
      TS(3,2)=SS(2,2,1)*TS(2,1)+TS(2,2)                                 BURZ0249
      TS(3,3)=SS(2,3,3)*TS(2,3)+TS(2,3)                                 BURZ0250
      DO 51 I=1,3                                                       BURZ0251
 51   IF (NBR.EQ.6.AND.TS(3,1).EQ.0.5.AND.TS(3,2).EQ.0.5.AND.TS(3,3).EQ.BURZ0252
     10.5) TS(3,I)=0.0                                                  BURZ0253
      DO 52 I=1,3                                                       BURZ0254
      TS(4,I)=TS(2,I)                                                   BURZ0255
      DO 52 J=1,3                                                       BURZ0256
      TS(4,I)=TS(4,I)+SS(2,I,J)*TS(3,J)                                 BURZ0257
      DO 52 K=1,3                                                       BURZ0258
 52   SS(4,I,J)=SS(4,I,J)+SS(2,I,K)*SS(3,K,J)                           BURZ0259
      IF (NBL.EQ.1) GO TO 76                                            BURZ0260
      IF (NS.EQ.0) GO TO 56                                             BURZ0261
      M=ZEI(2,1)                                                        BURZ0262
      N=ZEI(3,1)                                                        BURZ0263
      IF (M.NE.N3(2).AND.N.NE.N3(2)) GO TO 55                           BURZ0264
      IF (M.EQ.N3(2).AND.N.EQ.N3(2)) GO TO 54                           BURZ0265
      IF (M.EQ.N3(2)) GO TO 53                                          BURZ0266
      IF (M.EQ.N3(9).OR.M.EQ.N3(12)) TE(3)=0.5                          BURZ0267
      E(1,1)=-1                                                         BURZ0268
      E(2,2)=1                                                          BURZ0269
      E(3,3)=1                                                          BURZ0270
      IF (M.NE.N3(12).AND.M.NE.N3(8)) GO TO 57                          BURZ0271
      TE(1)=0.5                                                         BURZ0272
      TE(2)=0.5                                                         BURZ0273
      GO TO 57                                                          BURZ0274
 53   E(1,1)=1                                                          BURZ0275
      E(2,2)=-1                                                         BURZ0276
      E(3,3)=-1                                                         BURZ0277
      IF (N.EQ.N3(9)) TE(3)=0.5                                         BURZ0278
      IF (N.EQ.N3(10)) TE(3)=0.25                                       BURZ0279
      IF (N.EQ.N3(10)) TE(2)=0.5                                        BURZ0280
      IF (ZEI(2,2).NE.N3(1)) GO TO 57                                   BURZ0281
      TE(1)=0.5                                                         BURZ0282
      TE(2)=0.5                                                         BURZ0283
      GO TO 57                                                          BURZ0284
 54   E(1,2)=1                                                          BURZ0285
      E(2,1)=1                                                          BURZ0286
      E(3,3)=-1                                                         BURZ0287
      IF (ZEI(2,2).NE.0.OR.NBR.EQ.6.OR.ZEI(1,2).EQ.0) GO TO 57          BURZ0288
      IF (ZEI(1,2).EQ.N3(1)) TE(3)=0.75                                 BURZ0289
      IF (ZEI(1,2).EQ.N3(2)) TE(3)=0.5                                  BURZ0290
      IF (ZEI(1,2).EQ.N3(3)) TE(3)=0.25                                 BURZ0291
      GO TO 57                                                          BURZ0292
 55   M=ZEI(2,1)                                                        BURZ0293
      E(1,1)=-1                                                         BURZ0294
      E(2,2)=1                                                          BURZ0295
      E(3,3)=1                                                          BURZ0296
      IF (M.EQ.N3(9).OR.M.EQ.N3(12)) TE(3)=0.5                          BURZ0297
      IF (M.EQ.N3(12).OR.M.EQ.N3(8)) TE(1)=0.5                          BURZ0298
      IF (M.EQ.N3(12).OR.M.EQ.N3(8)) TE(2)=0.5                          BURZ0299
      GO TO 57                                                          BURZ0300
 56   E(1,1)=-1                                                         BURZ0301
      E(2,2)=1                                                          BURZ0302
      E(3,3)=1                                                          BURZ0303
      IF (ZEI(2,1).EQ.N3(9).OR.ZEI(2,1).EQ.N3(12)) TE(3)=0.5            BURZ0304
      IF (ZEI(2,1).EQ.N3(8).OR.ZEI(2,1).EQ.N3(12)) TE(2)=0.5            BURZ0305
      IF (ZEI(2,1).EQ.N3(8).OR.ZEI(2,1).EQ.N3(12)) TE(1)=0.5            BURZ0306
      IF (ZEI(1,3).EQ.N3(12).OR.ZEI(1,4).EQ.N3(12)) TE(1)=TE(1)+0.5     BURZ0307
 57   NE=4                                                              BURZ0308
      GO TO 74                                                          BURZ0309
C-----HEXAGONAL                                                         BURZ0310
 58   NG=3                                                              BURZ0311
      M=ZEI(1,1)                                                        BURZ0312
      N=ZEI(1,2)                                                        BURZ0313
      IF (M.EQ.N3(16).AND.N.EQ.N3(3)) NS=0                              BURZ0314
      IF (M.EQ.N3(6)) GO TO 61                                          BURZ0315
      SS(2,1,2)=-1                                                      BURZ0316
      SS(2,2,1)=1                                                       BURZ0317
      SS(2,2,2)=-1                                                      BURZ0318
      SS(2,3,3)=1                                                       BURZ0319
      IF (N.EQ.N3(1)) TS(2,3)=1.0/3.0                                   BURZ0320
      IF (N.EQ.N3(2)) TS(2,3)=2.0/3.0                                   BURZ0321
      SS(3,1,1)=-1                                                      BURZ0322
      SS(3,2,1)=-1                                                      BURZ0323
      SS(3,1,2)=1                                                       BURZ0324
      SS(3,3,3)=1                                                       BURZ0325
      TS(3,3)=2.0*TS(2,3)                                               BURZ0326
      IF (TS(3,3).GE.1.0) TS(3,3)=TS(3,3)-1.0                           BURZ0327
      IF (NBL.EQ.1.AND.N.NE.N3(6)) GO TO 76                             BURZ0328
      IF (N.NE.N3(6)) GO TO 60                                          BURZ0329
      NG=NG+NG                                                          BURZ0330
      DO 59 I=1,3                                                       BURZ0331
      DO 59 J=1,3                                                       BURZ0332
      DO 59 K=1,3                                                       BURZ0333
      SS(3+I,J,K)=SS(I,J,K)                                             BURZ0334
 59   SS(3+I,3,3)=-1                                                    BURZ0335
 60   IF (NBL.EQ.1) GO TO 76                                            BURZ0336
      IF (ZEI(2,1).NE.N3(9).AND.ZEI(3,1).NE.N3(9)) GO TO 63             BURZ0337
      TS(4,3)=0.5                                                       BURZ0338
      TS(5,3)=0.5                                                       BURZ0339
      TS(6,3)=0.5                                                       BURZ0340
      GO TO 63                                                          BURZ0341
 61   NG=NG+NG                                                          BURZ0342
      SS(2,1,1)=1                                                       BURZ0343
      SS(2,1,2)=-1                                                      BURZ0344
      SS(2,2,1)=1                                                       BURZ0345
      SS(2,3,3)=1                                                       BURZ0346
      IF (N.EQ.N3(1)) TS(2,3)=1.0/6.0                                   BURZ0347
      IF (N.EQ.N3(2)) TS(2,3)=2.0/6.0                                   BURZ0348
      IF (N.EQ.N3(3)) TS(2,3)=3.0/6.0                                   BURZ0349
      IF (N.EQ.N3(4)) TS(2,3)=4.0/6.0                                   BURZ0350
      IF (N.EQ.N3(5)) TS(2,3)=5.0/6.0                                   BURZ0351
      DO 62 I=1,4                                                       BURZ0352
      DO 62 J=1,3                                                       BURZ0353
      TS(2+I,J)=TS(2,J)                                                 BURZ0354
      DO 62 K=1,3                                                       BURZ0355
      TS(2+I,J)=TS(2+I,J)+SS(2,J,K)*TS(1+I,K)                           BURZ0356
      IF (TS(2+I,J).GT.1.0) TS(2+I,J)=TS(2+I,J)-1.0                     BURZ0357
      DO 62 L=1,3                                                       BURZ0358
 62   SS(2+I,J,K)=SS(2+I,J,K)+SS(2,J,L)*SS(1+I,L,K)                     BURZ0359
      IF (NBL.EQ.1) GO TO 76                                            BURZ0360
 63   NG=NG+NG                                                          BURZ0361
      M=ZEI(2,1)                                                        BURZ0362
      N=ZEI(3,1)                                                        BURZ0363
      IF (M.EQ.N3(1)) GO TO 65                                          BURZ0364
      IF (M.EQ.N3(2)) GO TO 64                                          BURZ0365
      E(1,2)=-1                                                         BURZ0366
      E(2,1)=-1                                                         BURZ0367
      E(3,3)=1                                                          BURZ0368
      IF (M.EQ.N3(9)) TE(3)=0.5                                         BURZ0369
      GO TO 67                                                          BURZ0370
 64   E(1,2)=1                                                          BURZ0371
      E(2,1)=1                                                          BURZ0372
      E(3,3)=-1                                                         BURZ0373
      TE(3)=2.0*TS(2,3)                                                 BURZ0374
C-----GROUP P 31 I 2 AND P 32 I 2                                       BURZ0375
      IF (ZEI(1,1).EQ.N3(3).AND.(ZEI(1,2).EQ.N3(1).OR.ZEI(1,2).EQ.      BURZ0376
     1N3(2))) TE(3)=0.                                                  BURZ0377
      GO TO 67                                                          BURZ0378
 65   IF (N.EQ.N3(2)) GO TO 66                                          BURZ0379
      E(1,2)=1                                                          BURZ0380
      E(2,1)=1                                                          BURZ0381
      E(3,3)=1                                                          BURZ0382
      IF (N.EQ.N3(9)) TE(3)=0.5                                         BURZ0383
      GO TO 67                                                          BURZ0384
 66   E(1,2)=-1                                                         BURZ0385
      E(2,1)=-1                                                         BURZ0386
      E(3,3)=-1                                                         BURZ0387
      TE(3)=2.0*TS(2,3)                                                 BURZ0388
      IF (TE(3).GT.1.0) TE(3)=TE(3)-1.0                                 BURZ0389
 67   NE=6                                                              BURZ0390
      IF (ZEI(1,1).EQ.N3(3).OR.(ZEI(1,2).EQ.N3(3).AND.ZEI(1,1).EQ.      BURZ0391
     1N3(16))) NE=3                                                     BURZ0392
      GO TO 74                                                          BURZ0393
C-----CUBIC                                                             BURZ0394
 68   NG=12                                                             BURZ0395
      IF (NBL.EQ.3) NG=24                                               BURZ0396
      IF (ZEI(1,1).NE.N3(2).AND.ZEI(1,1).NE.N3(4).AND.ZEI(1,1).NE.      BURZ0397
     1N3(16)) NS=0                                                      BURZ0398
      DO 69 I=1,3                                                       BURZ0399
      DO 69 J=1,3                                                       BURZ0400
      SS(1+I,J,J)=1                                                     BURZ0401
      IF (I.EQ.J) GO TO 69                                              BURZ0402
      SS(1+I,J,J)=-1                                                    BURZ0403
      IF (ZEI(1,1).EQ.N3(12)) TS(1+I,J)=0.5                             BURZ0404
      IF (ZEI(1,1).EQ.N3(10)) TS(1+I,J)=0.25                            BURZ0405
 69   CONTINUE                                                          BURZ0406
      IF (ZEI(1,1).NE.N3(7).AND.ZEI(3,1).NE.N3(10).AND.ZEI(1,2).NE.N3(3)BURZ0407
     1.AND.ZEI(1,2).NE.N3(1).OR.NBR.EQ.5) GO TO 71                      BURZ0408
      DO 70 I=1,3                                                       BURZ0409
      TS(1+I,I)=0.5                                                     BURZ0410
      K=I+1                                                             BURZ0411
      IF (K.EQ.4) K=1                                                   BURZ0412
 70   TS(1+I,K)=0.5                                                     BURZ0413
 71   DO 72 I=1,4                                                       BURZ0414
      DO 72 J=1,3                                                       BURZ0415
      DO 72 K=1,3                                                       BURZ0416
      L=J+1                                                             BURZ0417
      IF (L.EQ.4) L=1                                                   BURZ0418
      M=J-1                                                             BURZ0419
      IF (M.EQ.0) M=3                                                   BURZ0420
      SS(4+I,J,K)=SS(I,L,K)                                             BURZ0421
      SS(8+I,J,K)=SS(I,M,K)                                             BURZ0422
      TS(4+I,J)=TS(I,L)                                                 BURZ0423
 72   TS(8+I,J)=TS(I,M)                                                 BURZ0424
      IF (NG.EQ.12) GO TO 76                                            BURZ0425
      NE=12                                                             BURZ0426
      E(1,2)=1                                                          BURZ0427
      E(2,1)=1                                                          BURZ0428
      E(3,3)=1                                                          BURZ0429
      IF (ZEI(3,1).EQ.N3(2)) E(3,3)=-1                                  BURZ0430
      IF (ZEI(3,1).EQ.N3(9)) TE(3)=0.5                                  BURZ0431
      DO 73 I=1,3                                                       BURZ0432
      IF (ZEI(3,1).EQ.N3(12).OR.ZEI(1,2).EQ.N3(2)) TE(I)=0.5            BURZ0433
 73   IF (ZEI(3,1).EQ.N3(10).OR.ZEI(1,2).EQ.N3(1).OR.ZEI(1,2).EQ.N3(3)) BURZ0434
     1TE(I)=0.25                                                        BURZ0435
      IF (ZEI(1,2).EQ.N3(1).AND.NBR.EQ.1) TE(1)=0.75                    BURZ0436
      IF ((ZEI(1,2).NE.N3(1).OR.NBR.NE.6).AND.(ZEI(1,2).NE.N3(3).OR.NBR BURZ0437
     1.NE.1)) GO TO 74                                                  BURZ0438
      TE(2)=0.75                                                        BURZ0439
      TE(3)=0.75                                                        BURZ0440
 74   DO 75 I=1,NE                                                      BURZ0441
      DO 75 J=1,3                                                       BURZ0442
      TS(NE+I,J)=TE(J)                                                  BURZ0443
      DO 75 K=1,3                                                       BURZ0444
      TS(NE+I,J)=TS(NE+I,J)+E(J,K)*TS(I,K)                              BURZ0445
      DO 75 L=1,3                                                       BURZ0446
 75   SS(NE+I,J,K)=SS(NE+I,J,K)+E(J,L)*SS(I,L,K)                        BURZ0447
 76   DO 81 I=1,NG                                                      BURZ0448
      DO 81 J=1,3                                                       BURZ0449
 77   IF (TS(I,J).GE.1.0) GO TO 78                                      BURZ0450
      GO TO 79                                                          BURZ0451
 78   TS(I,J)=TS(I,J)-1.0                                               BURZ0452
      GO TO 77                                                          BURZ0453
 79   IF (TS(I,J).LT.0.0) GO TO 80                                      BURZ0454
      GO TO 81                                                          BURZ0455
 80   TS(I,J)=TS(I,J)+1.0                                               BURZ0456
      GO TO 79                                                          BURZ0457
 81   CONTINUE                                                          BURZ0458
      ISYSTM=ISYS(SYS)                                                  BURZ0459
      IF (NS.EQ.0) ISYMCE=1                                             BURZ0460
      IF (NS.EQ.1) ISYMCE=0                                             BURZ0461
      RETURN                                                            BURZ0462
      END                                                               BURZ0463
      BLOCK DATA BLKD                                                   BLKD0000
C-----CONTAINS LITERAL DATA FOR LAZY                                    BLKD0001
      COMMON /ND/ NM/WAVEL/ M/BRAF/IB,CT /FLOR/ LPF,CV                  BLKD0002
      INTEGER CV,CT                                                     BLKD0003
      DIMENSION NM(20),M(20),IB(8),CV(6),LPF(6),CT(8)                   BLKD0004
      DATA  NM(1)/1H1/, NM(2)/1H2/, NM(3)/1H3/, NM(4)/1H4/, NM(5)/1H5/, BLKD0005
     1NM(6)/1H6/,NM(7)/1HA/,NM(8)/1HB/,NM(9)/1HC/,NM(10)/1HD/,NM(11)/1HMBLKD0006
     2/,NM(12)/1HN/,NM(13)/1HP/,NM(14)/4HCU  /,NM(15)/1H//,NM(16)/1H-/, BLKD0007
     3NM(17)/1H /, NM(18)/2H  /,NM(19)/4H    /,NM(20)/2HSP/             BLKD0008
      DATA LPF(1)/0/,LPF(2)/1/,LPF(3)/2/,LPF(4)/3/,LPF(5)/4/,LPF(6)/0/  BLKD0009
      DATA CV(1)/2HDS/,CV(2)/2H 1/,CV(3)/2HNE/,CV(4)/2HGN/,CV(5)/2HGH/,CBLKD0010
     1V(6)/2H  /                                                        BLKD0011
      DATA IB(1)/1/,IB(2)/1/,IB(3)/2/,IB(4)/3/,IB(5)/4/,IB(6)/5/,IB(7)/6BLKD0012
     1/,IB(8)/7/                                                        BLKD0013
      DATA CT(1)/1H /,CT(2)/1HP/,CT(3)/1HI/,CT(4)/1HR/,CT(5)/1HF/,CT(6)/BLKD0014
     11HA/,CT(7)/1HB/,CT(8)/1HC/                                        BLKD0015
      DATA M(1)/4HCRA1/,M(2)/4HCRA2/,M(3)/4HCRB /,M(4)/4HCR  /,M(5)/4HFEBLKD0016
     1A1/,M(6)/4HFEA2/,M(7)/4HFEB /,M(8)/4HFE  /,M(9)/4HCUA1/,M(10)/4HCUBLKD0017
     2A2/,M(11)/4HCUB /,M(12)/4HCU  /,M(13)/4HMOA1/,M(14)/4HMOA2/,M(15)/BLKD0018
     34HMOB /,M(16)/4HMO  /,M(17)/4HAGA1/,M(18)/4HAGA2/,M(19)/4HAGB /,M(BLKD0019
     420)/4HAG  /                                                       BLKD0020
      END                                                               BLKD0021
      SUBROUTINE EQUI                                                   EQUI0000
C-----PRINTS EQUIPOINTS STORED IN TS,FS,ISYMCE AND IBRAVL               EQUI0001
      COMMON /EQUO/ TS,FS,NG,ISYMCE,IBRAVL                              EQUI0002
      COMMON /UNITS/ IEIN,NPT,IAUS                                                EQUI0003
      INTEGER DIG,SYMB1,SYMB2                                           EQUI0004
      DIMENSION TS(3,24), FS(3,3,24), CON1(7), SYMB1(8), SYMB2(9), DIG(1EQUI0005
     13), IB(24), IP(12), N3(9)                                         EQUI0006
      DATA IB(1)/4H1/2 /,IB(2)/4H2/3 /,IB(3)/4H1/2 /,IB(4)/4H 0  /,IB(5)EQUI0007
     1/4H1/2 /,IB(6)/4H1/2 /,IB(7)/4H1/2 /,IB(8)/4H1/3 /,IB(9)/4H1/2 /,IEQUI0008
     2B(10)/4H1/2 /,IB(11)/4H 0  /,IB(12)/4H1/2 /,IB(13)/4H1/2)/,IB(14)/EQUI0009
     34H1/3 /,IB(15)/4H 0, /,IB(16)/4H1/2)/,IB(17)/4H1/2)/,IB(18)/4H 0 )EQUI0010
     4/,IB(19)/4H1/3 /,IB(20)/4H1/2 /,IB(21)/4H2/3 /,IB(22)/4H 0  /,IB(2EQUI0011
     53)/4H2/3)/,IB(24)/4H1/2,/                                         EQUI0012
      DATA CON1(1)/0.75/,CON1(2)/0.6667/,CON1(3)/0.5/,CON1(4)/0.3333/,COEQUI0013
     1N1(5)/0.25/,CON1(6)/0.16667/,CON1(7)/0.83333/                     EQUI0014
      DATA SYMB1(1)/3H3/4/,SYMB1(2)/3H2/3/,SYMB1(3)/3H1/2/,SYMB1(4)/3H1/EQUI0015
     13/,SYMB1(5)/3H1/4/,SYMB1(6)/3H1/6/,SYMB1(7)/3H5/6/,SYMB1(8)/3H   /EQUI0016
      DATA SYMB2(1)/3H +X/,SYMB2(2)/3H  X/,SYMB2(3)/3H -X/,SYMB2(4)/3H +EQUI0017
     1Y/,SYMB2(5)/3H  Y/,SYMB2(6)/3H -Y/,SYMB2(7)/3H +Z/,SYMB2(8)/3H  Z/EQUI0018
     2,SYMB2(9)/3H -Z/                                                  EQUI0019
      DATA N3(1)/1H /,N3(2)/3H   /,N3(3)/4H    /,N3(4)/1H,/,N3(5)/4H+(0 EQUI0020
     1/,N3(6)/4H0 0,/,N3(7)/4H 0  /,N3(8)/4H1/2 /,N3(9)/4H1/2)/         EQUI0021
      WRITE (NPT,15)                                                    EQUI0022
      DIG(13)=N3(1)                                                     EQUI0023
      IF (ISYMCE.EQ.1) DIG(13)=N3(4)                                    EQUI0024
C-----FILL OUTPUT STRING WITH BLANKS                                    EQUI0025
      DO 1 NN=1,12                                                      EQUI0026
      IP(NN)=N3(3)                                                      EQUI0027
 1    DIG(NN)=SYMB1(8)                                                  EQUI0028
C-----FILL OUTPUT STRING IP WITH BRAVAIS LATTICE VECTORS                EQUI0029
      IF (IBRAVL.LT.2) GO TO 4                                          EQUI0030
C-----FIRST VECTOR                                                      EQUI0031
      IP(1)=N3(5)                                                       EQUI0032
      IP(2)=N3(6)                                                       EQUI0033
C-----SECOND VECTOR                                                     EQUI0034
      DO 2 I=1,3                                                        EQUI0035
      I1=I+2                                                            EQUI0036
      I2=IBRAVL-1                                                       EQUI0037
      I3=I*6-6                                                          EQUI0038
 2    IP(I1)=IB(I2+I3)                                                  EQUI0039
      IF ((IBRAVL.LT.3).OR.(IBRAVL.GT.4)) GO TO 4                       EQUI0040
C-----THIRD VECTOR                                                      EQUI0041
      I2=16+IBRAVL                                                      EQUI0042
      DO 3 I=1,3                                                        EQUI0043
      I1=I+5                                                            EQUI0044
      I3=I*2-2                                                          EQUI0045
 3    IP(I1)=IB(I2+I3)                                                  EQUI0046
C-----FORTH VECTOR                                                      EQUI0047
      IF (IBRAVL.EQ.3) GO TO 4                                          EQUI0048
      IP(9)=N3(7)                                                       EQUI0049
      IP(10)=N3(8)                                                      EQUI0050
      IP(11)=N3(9)                                                      EQUI0051
C-----LOOP OVER NUMBER OF EQUIPOINTS                                    EQUI0052
 4    DO 14 I=1,NG                                                      EQUI0053
C-----FILL OUTPUT STRING WITH BLANKS                                    EQUI0054
      DO 5 NN=1,12                                                      EQUI0055
 5    DIG(NN)=N3(2)                                                     EQUI0056
      ANTI=1.                                                           EQUI0057
      NN=1                                                              EQUI0058
C-----LOOP OVER X Y Z  COORDINATES                                      EQUI0059
 6    DO 12 J=1,3                                                       EQUI0060
      TS1=ANTI*TS(J,I)                                                  EQUI0061
      IF (TS1.LT.0.) TS1=1.+TS1                                         EQUI0062
      N1=1                                                              EQUI0063
      IF (TS1.EQ.0.) GO TO 9                                            EQUI0064
      DO 7 II=1,7                                                       EQUI0065
      DIF=TS1-CON1(II)                                                  EQUI0066
      DIF=ABS(DIF)                                                      EQUI0067
      IF (DIF.LT..010) GO TO 8                                          EQUI0068
 7    CONTINUE                                                          EQUI0069
      WRITE (NPT,16)                                                    EQUI0070
      RETURN                                                            EQUI0071
 8    DIG(NN)=SYMB1(II)                                                 EQUI0072
      NN=NN+1                                                           EQUI0073
      N1=2                                                              EQUI0074
 9    L=1                                                               EQUI0075
C-----LOOP OVER ROWS IN MATRIX                                          EQUI0076
      DO 11 M1=1,3                                                      EQUI0077
      FS1=ANTI*FS(M1,J,I)                                               EQUI0078
      IF (FS1.EQ.0.) GO TO 10                                           EQUI0079
      IF (FS1.EQ.1.) L=L-N1+2                                           EQUI0080
      IF (FS1.EQ.-1.) L=L+2                                             EQUI0081
      N1=N1+1                                                           EQUI0082
      DIG(NN)=SYMB2(L)                                                  EQUI0083
      NN=NN+1                                                           EQUI0084
 10   L=M1*3+1                                                          EQUI0085
 11   CONTINUE                                                          EQUI0086
      NN=NN-N1+3                                                        EQUI0087
 12   CONTINUE                                                          EQUI0088
      IF (ANTI.EQ.-1.) GO TO 13                                         EQUI0089
      ANTI=-1.                                                          EQUI0090
      IF (ISYMCE.EQ.1) GO TO 6                                          EQUI0091
 13   WRITE (NPT,17) (DIG(I1),I1=1,6),DIG(7),DIG(8),DIG(13),DIG(9),DIG(1EQUI0092
     10),DIG(13),DIG(11),DIG(12),(IP(I1),I1=1,12)                       EQUI0093
 14   CONTINUE                                                          EQUI0094
      RETURN                                                            EQUI0095
C                                                                       EQUI0096
 15   FORMAT (/27H EQUIVALENT POINT POSITIONS/)                         EQUI0097
 16   FORMAT (33H EQUIPOINT CODE BADLY INTERPRETED)                     EQUI0098
 17   FORMAT (1X,2(2A3,1H,),2A3,5X,2(2A3,A1),2A3,2X,12A4)               EQUI0099
      END                                                               EQUI0100
      FUNCTION BRA (SYMBR)                                              BRAS0000
C-----ASSIGNS SEQUENCE NUMBER BRA TO BRAVAIS LATTICE SYMBOL SYMBR       BRAS0001
      COMMON /BRAF/ IB,CU                                               BRAS0002
      INTEGER CU,SYMBR                                                  BRAS0003
      DIMENSION IB(8), CU(8)                                            BRAS0004
      DO 1 I=1,8                                                        BRAS0005
      IF (SYMBR-CU(I)) 1,2,1                                            BRAS0006
 1    CONTINUE                                                          BRAS0007
      BRA=IB(1)                                                         BRAS0008
      RETURN                                                            BRAS0009
 2    BRA=IB(I)                                                         BRAS0010
      RETURN                                                            BRAS0011
      END                                                               BRAS0012
